      PROGRAM CRLAD
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEADA*70,HEADC*70,FINA*40,FINC*40,FOUT*40
      DIMENSION  A0(252,52),A1(252,52),C0(252,52),C1(252,52),U(17),
     +           X(50),Z(252),BA(252),BC(252),E(252),LS(252)
C
C    PROGRAM CRLAD PROVIDES A SIMULATED P-VALUE FOR TESTING A NESTED NULL
C       MODEL RELATIVE TO A FULL ALTERNATIVE MODEL FOR LAD REGRESSION
C
C          PRESENT SIZE LIMITS ON PROGRAM CRLAD ARE THE FOLLOWING:
C           M = 250 OBSERVED CASES & N = 50 INDEPENDENT VARIABLES
C
      ONE = 1.0D0
      ZERO = 0.0D0
      TOLER = 1.0D-9
      WRITE(*,10) '*** PROGRAM CRLAD ***'
   10 FORMAT(T19,A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA FOR NULL MODEL:'
      READ(*,12) FINA
   12 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA FOR ALTERNATIVE MODEL:'
      READ(*,12) FINC
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,12) FOUT
      WRITE(*,*) 'ENTER # OF SIMULATIONS FOR TESTING NULL MODEL:'
      READ(*,*) MS
      TS = ONE*MS
      WRITE(*,*) 'ENTER RANDOM # GENERATOR SEED (ANY NON-ZERO INTEGER):'
      READ(*,*) ISEED
      OPEN(4,FILE=FINA)
      OPEN(5,FILE=FINC)
      OPEN(7,FILE=FOUT,STATUS='NEW')
C
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 100 II = 1,17
        S = 0.0D0
        T = 0.5D0
        DO 99 JJ = 1,K
          M1 = MOD(MOD(I1*J1,179)*K1,179)
          I1 = J1
          J1 = K1
          K1 = M1
          L1 = MOD(53*L1+1,169)
          IF(MOD(L1*M1,64).GE.32) S = S+T
          T = T/2
   99   CONTINUE
        U(II) = S
  100 CONTINUE
C
      READ(4,12) HEADA
      READ(4,*) MA,NA
      NA1 = NA+1
      NA2 = NA+2
      MA1 = MA+1
      MA2 = MA+2
      READ(4,*) ((A0(I,J),J = 1,NA1),I = 1,MA)
      CLOSE(4)
      DO 1000 I = 1,MA
         A0(I,NA2) = ZERO
         BA(I) = A0(I,NA1)
 1000 CONTINUE
      DO 1002 J = 1,NA2
         A0(MA1,J) = ZERO
         A0(MA2,J) = ZERO
 1002 CONTINUE
      READ(5,12) HEADC
      READ(5,*) MC,NC
      NC1 = NC+1
      NC2 = NC+2
      MC1 = MC+1
      MC2 = MC+2
      READ(5,*) ((C0(I,J),J = 1,NC1),I = 1,MC)
      CLOSE(5)
      DO 1005 I = 1,MC
         C0(I,NC2) = ZERO
         BC(I) = C0(I,NC1)
 1005 CONTINUE
      DO 1007 J =  1,NC2
         C0(MC1,J) = ZERO
         C0(MC2,J) = ZERO
 1007 CONTINUE
      IF(MA.EQ.MC) THEN
         M = MA
      ELSE
         STOP 'SAMPLE SIZES OF NULL AND ALTERNATIVE MODELS NOT EQUAL'
      END IF
C
      M1 = M+1
      M2 = M+2
C
      WRITE(7,1030)
 1030 FORMAT(T20,'*** OUTPUT OF CRLAD ANALYSIS ***')
      WRITE(7,1035) HEADA
 1035 FORMAT(T2,'NULL DATA: ',A)
      WRITE(7,1040) HEADC
 1040 FORMAT(T2,'ALTERNATIVE DATA: ',A)
C
      DO 1080 I = 1,M2
         DO 1060 J = 1,NA2
            A1(I,J) = A0(I,J)
 1060    CONTINUE
         DO 1070 J = 1,NC2
            C1(I,J) = C0(I,J)
 1070    CONTINUE
 1080 CONTINUE
C
      CALL R1(M,NA,A1,BA,TOLER,X,Z,LS)
      SA = A1(M1,NA1)
      CALL R1(M,NC,C1,BC,TOLER,X,E,LS)
      SC = C1(M1,NC1)
      TOBS = (SC/SA)*(ONE+1.0D-11)
      WRITE(7,1090) 'VALUE OF OBSERVED STATISTIC (SA1/SA0) = ',TOBS
 1090 FORMAT(T6,A,G16.8)
C
      SS = ZERO
      DO 2000 L = 1,MS
         CALL SAMPWOR(M,M,U,Z)
         DO 1200 I = 1,M
            A0(I,NA1) = Z(I)
            BA(I) = Z(I)
            C0(I,NC1) = Z(I)
            BC(I) = Z(I)
 1200    CONTINUE
         DO 1250 I = 1,M2
            DO 1230 J = 1,NA2
               A1(I,J) = A0(I,J)
 1230       CONTINUE
            DO 1240 J = 1,NC2
               C1(I,J) = C0(I,J)
 1240       CONTINUE
 1250    CONTINUE
         CALL R1(M,NA,A1,BA,TOLER,X,E,LS)
         SA = A1(M1,NA1)
         CALL R1(M,NC,C1,BC,TOLER,X,E,LS)
         SC = C1(M1,NC1)
         T = SC/SA
         IF(T.LE.TOBS) SS = SS+ONE
 2000 CONTINUE
      PVALUE = SS/TS
      WRITE(7,2100) 'RANDOM # GENERATOR SEED = ',ISEED
 2100 FORMAT(T6,A,I8)
      WRITE(7,2100) 'NUMBER OF SIMULATIONS OF TEST STATISTIC = ',MS
      WRITE(7,1090) 'ESTIMATED P-VALUE FOR NESTED LAD TEST = ',PVALUE
      END
C
C
      SUBROUTINE R1(M,N,A,B,TOLER,X,E,LS)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(252,52),X(50),E(252),B(252),LS(252)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      M2 = M+2
      N2 = N+2
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE SAMPWOR(M,N,U,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17),X(252)
C
C         SUBROUTINE SAMPWOR DRAWS A SAMPLE OF SIZE N FROM
C            A POPULATION OF SIZE M WITHOUT REPLACEMENT
C
C     M: SIZE OF POPULATION
C     N: SIZE OF SAMPLE DRAWN WITHOUT REPLACEMENT (1 </= N </= M)
C     X: REAL INPUT WHICH CONTAINS X(1),...,X(M) POPULATION VALUES
C     UNI(U): UNIFORM RANDOM NUMBER GENERATOR ON (0,1)
C
      DO 10 I = 1,N
         J = INT(I+(M-I+1)*UNI(U))
         BIN = X(J)
         X(J) = X(I)
         X(I) = BIN
   10 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
