      PROGRAM EREGRES
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  FIN*40,FOUT*40,HEAD*80
C
C  THIS PROGRAM IS CAPABLE OF MULTIPLE RUNS.  LEAVE NO BLANK LINES BETWEEN
C  DATA SETS SINCE THE FIRST LINE FOLLOWING THE LAST DATA ENTRY MAY BE
C  READ AS A BLANK PROBLEM HEAD FOR THE NEXT DATA SET.  THIS PROGRAM ALSO
C  OBTAINS THE LOWER QUARTILE, MEDIAN AND UPPER QUARTILE RESIDUAL VALUES
C  OF EACH GROUP.
C
      WRITE(*,1000) '*** PROGRAM EREGRES ***'
 1000 FORMAT(/,T18,A)
      WRITE(*,1100) 'PROGRAM EREGRES COMPUTES EMRPP ANALYSES ',
     +              'OF LAD RESIDUAL DATA','OF AN ',
     +              'EXISTING DATA SET, USING THE ACM ALGORITHM ',
     +              'NUMBER 478.','PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 30 OBSERVATIONS,',
     +              'N = 20 INDEPENDENT VARIABLES.',
     +              'RESULTS OF PROGRAM ARE IN NAMED OUTPUT FILE.',
     +              'NOTE THAT THE DEPENDENT VARIABLE (Y) MUST BE ',
     +              'THE LAST VARIABLE','(THAT IS THE RIGHT-MOST ',
     +              'VARIABLE) IN THE DATA SET.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T2,A,/,T10,A,/,
     +   T10,A,/,T2,A,/,T2,A,A,/,T2,A,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1200) FOUT
      TOLER = 1.0D-9
      WRITE(*,1300) 'TOLERANCE = ', TOLER
 1300 FORMAT(T10,A,E10.4)
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
 1500 READ(4,1200,END=1600) HEAD
      GO TO 1800
 1600 GO TO 2000
 1800 CALL LEAST(TOLER,HEAD)
      GO TO 1500
 2000 CLOSE(4)
      CLOSE(7)
      END
C
C
      SUBROUTINE LEAST(TOLER,HEAD)
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80
      INTEGER    CFORM
      DIMENSION  X(20),E(30),B(30),LS(30),ITHGRP(10),W(30),
     +           Y(10,3),A(32,22),DATA(30,2)
C
      READ(4,*) M,N,NGRPS,(ITHGRP(I),I = 1,NGRPS)
      READ(4,*) ((A(I,J),J = 1,N+1),I = 1,M)
      DO 1000 I = 1,M
         B(I) = A(I,N+1)
 1000 CONTINUE
      WRITE(7,1100) HEAD
 1100 FORMAT(A)
      WRITE(7,1400)
 1400 FORMAT(T20,'*** OUTPUT OF EREGRES ANALYSIS ***',/)
      IF(N.EQ.0) THEN
         SUMRE = 0.0D0
         DO 1500 I = 1,M
            E(I) = A(I,1)
            SUMRE = SUMRE+DABS(E(I))
 1500    CONTINUE
         GO TO 1950
      END IF
C
      CALL L1(M,N,A,B,TOLER,X,E,LS)
C
      DO 1700 I = 1,N
         WRITE(7,1600) 'LAD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      IRANK = A(M+1,N+2)
      ITER = A(M+2,N+2)
      IEXCODE = A(M+2,N+1)
      SUMRE = A(M+1,N+1)
      WRITE(7,1800) IRANK,ITER,IEXCODE
 1800 FORMAT(/,T5,'MATRIX RANK = ',I3,/,T5,'ITERATIONS =  ',I3,/,T5,
     +   'EXIT CODE =   ',I3)
      WRITE(7,1900) 'NOTE: EXIT CODE 0 INDICATES A NON-UNIQUE ',
     +   'SOLUTION.','NOTE: EXIT CODE 1 INDICATES A SUCCESSFUL ',
     +   'SOLUTION.','NOTE: EXIT CODE 2 INDICATES ROUNDING ERRORS.'
 1900 FORMAT(/,T5,A,A,/,T5,A,A,/,T5,A)
 1950 WRITE(7,2000) M,N,SUMRE
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I3,/,T5,'INDEPENDENT',
     +   ' VARIABLES = ',I2,/,T5,'SUM OF ABSOLUTE VALUES OF THE',
     +   ' RESIDUALS = ',G15.8,/)
C
      DO 2100 I = 1,M
         DATA(I,1) = E(I)
 2100 CONTINUE
C
      DO 2200 J = 1,ITHGRP(1)
         W(J) = E(J)
 2200 CONTINUE
      CALL MED(ITHGRP(1),Y(1,1),Y(1,2),Y(1,3),W)
      KC = ITHGRP(1)
      DO 2400 I = 2,NGRPS
         DO 2300 J = KC+1,KC+ITHGRP(I)
            W(J-KC) = E(J)
 2300    CONTINUE
         CALL MED(ITHGRP(I),Y(I,1),Y(I,2),Y(I,3),W)
         KC = KC+ITHGRP(I)
 2400 CONTINUE
C
      ID = 1
      V = 1.0D0
      SUP = 1.0D50
      CFORM = 1
      CALL EMRPP(M,ID,V,SUP,CFORM,NGRPS,ITHGRP,Y,DATA)
C
      RETURN
      END
C
C
      SUBROUTINE L1(M,N,A,B,TOLER,X,E,LS)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  A(32,22),X(20),E(30),B(30),LS(30)
      LOGICAL  STAGE,TEST
      DATA  BIG/1.0D200/
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      M1 = M+1
      N1 = N+1
      M2 = M+2
      N2 = N+2
      DO 10 J = 1,N
         A(M2,J) = J
         X(J) = ZERO
 10   CONTINUE
      DO 40 I = 1,M
         A(I,N2) = N+I
         A(I,N1) = B(I)
         IF(B(I).GE.ZERO) GO TO 30
         DO 20 J = 1,N2
            A(I,J) = -A(I,J)
 20      CONTINUE
 30      E(I) = ZERO
 40   CONTINUE
C
      DO 60 J = 1,N1
         SUM = ZERO
         DO 50 I = 1,M
            SUM = SUM+A(I,J)
 50      CONTINUE
         A(M1,J) = SUM
 60   CONTINUE
C
      STAGE = .TRUE.
      KOUNT = 0
      KR = 1
      KL = 1
 70   AMAX = -ONE
      DO 80 J = KR,N
         IF(DABS(A(M2,J)).GT.N) GO TO 80
         D = DABS(A(M1,J))
         IF(D.LE.AMAX) GO TO 80
         AMAX = D
         IN = J
 80   CONTINUE
      IF(A(M1,IN).GE.ZERO) GO TO 100
      DO 90 I = 1,M2
         A(I,IN) = -A(I,IN)
 90   CONTINUE
C
 100  K = 0
      DO 110 I = KL,M
         D = A(I,IN)
         IF(D.LE.TOLER) GO TO 110
         K = K+1
         B(K) = A(I,N1)/D
         LS(K) = I
         TEST = .TRUE.
 110  CONTINUE
 120  IF(K.GT.0) GO TO 130
      TEST = .FALSE.
      GO TO 150
 130  AMIN = BIG
      DO 140 I = 1,K
         IF(B(I).GE.AMIN) GO TO 140
         J = I
         AMIN = B(I)
         IOUT = LS(I)
 140  CONTINUE
      B(J) = B(K)
      LS(J) = LS(K)
      K = K-1
C
 150  IF(TEST.OR..NOT.STAGE) GO TO 170
      DO 160 I = 1,M2
         D = A(I,KR)
         A(I,KR) = A(I,IN)
         A(I,IN) = D
 160  CONTINUE
      KR = KR+1
      GO TO 260
 170  IF(TEST) GO TO 180
      A(M2,N1) = TWO
      GO TO 350
 180  PIVOT = A(IOUT,IN)
      IF(A(M1,IN)-PIVOT-PIVOT.LE.TOLER) GO TO 200
      DO 190 J = KR,N1
         D = A(IOUT,J)
         A(M1,J) = A(M1,J)-D-D
         A(IOUT,J) = -D
 190  CONTINUE
      A(IOUT,N2) = -A(IOUT,N2)
      GO TO 120
C
 200  DO 210 J = KR,N1
         IF(J.EQ.IN) GO TO 210
         A(IOUT,J) = A(IOUT,J)/PIVOT
 210  CONTINUE
      DO 220 J = KR,N1
         IF(J.EQ.IN) GO TO 220
         CALL COL(A(1,J),A(1,IN),A(IOUT,J),M1,IOUT)
 220  CONTINUE
      DO 240 I = 1,M1
         IF(I.EQ.IOUT) GO TO 240
         A(I,IN) = -A(I,IN)/PIVOT
 240  CONTINUE
      A(IOUT,IN) = ONE/PIVOT
      D = A(IOUT,N2)
      A(IOUT,N2) = A(M2,IN)
      A(M2,IN) = D
      KOUNT = KOUNT+1
      IF(.NOT.STAGE) GO TO 270
C
      KL = KL+1
      DO 250 J = KR,N2
         D = A(IOUT,J)
         A(IOUT,J) = A(KOUNT,J)
         A(KOUNT,J) = D
 250  CONTINUE
 260  IF(KOUNT+KR.NE.N1) GO TO 70
C
      STAGE = .FALSE.
C
 270  AMAX = -BIG
      DO 290 J = KR,N
         D = A(M1,J)
         IF(D.GE.ZERO) GO TO 280
         IF(D.GT.-TWO) GO TO 290
         D = -D-TWO
 280  IF(D.LE.AMAX) GO TO 290
      AMAX = D
      IN = J
 290  CONTINUE
      IF(AMAX.LE.TOLER) GO TO 310
      IF(A(M1,IN).GT.ZERO) GO TO 100
      DO 300 I = 1,M2
         A(I,IN) = -A(I,IN)
 300  CONTINUE
      A(M1,IN) = A(M1,IN)-TWO
      GO TO 100
C
 310  L = KL-1
      DO 330 I = 1,L
         IF(A(I,N1).GE.ZERO) GO TO 330
         DO 320 J = KR,N2
            A(I,J) = -A(I,J)
 320     CONTINUE
 330  CONTINUE
      A(M2,N1) = ZERO
      IF(KR.NE.1) GO TO 350
      DO 340 J = 1,N
         D = DABS(A(M1,J))
         IF(D.LE.TOLER.OR.TWO-D.LE.TOLER) GO TO 350
 340  CONTINUE
      A(M2,N1) = ONE
 350  DO 380 I = 1,M
         K = A(I,N2)
         D = A(I,N1)
         IF(K.GT.0) GO TO 360
         K = -K
         D = -D
 360  IF(I.GE.KL) GO TO 370
      X(K) = D
      GO TO 380
 370  K = K-N
      E(K) = D
 380  CONTINUE
      A(M2,N2) = KOUNT
      A(M1,N2) = N1-KR
      SUM = ZERO
      DO 390 I = KL,M
         SUM = SUM+A(I,N1)
 390  CONTINUE
      A(M1,N1) = SUM
      RETURN
      END
C
C
      SUBROUTINE COL(V1,V2,AMLT,M1,IOUT)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  V1(M1),V2(M1)
C
      DO 10 I = 1,M1
         IF(I.EQ.IOUT) GO TO 10
         V1(I) = V1(I)-V2(I)*AMLT
  10  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE MED(N,Y1,Y2,Y3,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
C  THIS SUBROUTINE OBTAINS THE LOWER QUARTILE, MEDIAN AND UPPER QUARTILE
C  VALUES FOR UNIVARIATE DATA WHERE THE DATA SET'S SIZE IS AT LEAST TWO.
C
      DIMENSION  X(30)
C
      J = N
      K = J/2+1
   10 K = K-1
      W = X(K)
      GO TO 30
   20 W = X(J)
      X(J) = X(1)
      J = J-1
   30 II = K
   40 L = 2*II
      IF(L-J) 50,60,70
   50 IF(X(L+1).GE.X(L)) L = L+1
   60 IF(W.GE.X(L)) GO TO 70
      X(II) = X(L)
      II = L
      GO TO 40
   70 X(II) = W
      IF(K.GT.1) GO TO 10
      IF(J.GE.2) GO TO 20
      K1 = IDINT(0.25D0*N+0.5D0)
      Y1 = X(K1)
      K2 = IDINT(0.5D0*N+0.51D0)
      Y2= X(K2)
      L2= N/2
      IF(K2.EQ.L2) Y2 = (X(K2)+X(K2+1))/2
      K3 = IDINT(0.75D0*N+0.5D0)
      Y3 = X(K3)
      RETURN
      END
C
C
      SUBROUTINE EMRPP(N,R,V,SUP,CFORM,G,B,Y,DATA)
C
C         THE TEST STATISTIC ASSOCIATED WITH EXACT MULTI-RESPONSE PERMUTATION
C         PROCEDURES (EMRPP) IS CALCULATED IN THIS FORTRAN-77 PROGRAM.
C         THIS TEST IS DESIGNED TO ANALYZE MULTI-RESPONSE DATA AT
C         THE ORDINAL (OR HIGHER) LEVELS AND IS BASED ON THE AVERAGE
C         EUCLIDEAN DISTANCE BETWEEN OBJECT POSITIONS WITHIN A PRIORI
C         DISJOINT GROUPS OF OBJECTS IN A FINITE POPULATION WHERE
C         EACH POSITION IS A POINT IN AN R-DIMENSIONAL SPACE (THUS
C         THE ARGUMENTS OF EACH R-DIMENSIONAL POINT CORRESPOND TO
C         THE R MEASURED RESPONSES OF EACH OBJECT IN THE FINITE POPULATION
C         OF OBJECTS).  THIS PROGRAM ALSO CONTAINS THE TRUNCATED DISTANCE
C         OPTION (THE UPPER TRUNCATION CONSTANT IS TERMED SUP).  THE
C         PRESENT MAXIMUM VALUES OF G, N AND R IN THIS PROGRAM ARE
C         RESPECTIVELY 10, 30 AND 1.
C
C         PROGRAM MODIFIED 10/11/2000
C
C       EITHER OF THE FOUR FOLLOWING WEIGHTING FORMS MAY BE CHOSEN.
C            CFORM = 1:  C(I) = n(I)/sum(n(I))
C            CFORM = 2:  C(I) = (n(I)-1)/sum(n(I)-1)
C            CFORM = 3:  C(I) = 1/sum(1)
C            CFORM = 4:  C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))
C       CFORM IS PASSED AS THE FOURTH PARAMETER ON THE SECOND RECORD
C       IN THE DATA FILE.  WEIGHTS FOR EACH GROUP ARE CALCULATED IN
C       SUBROUTINE DIST, AND STORED IN ARRAY C(I).
C
      CHARACTER  HEAD*70
C
      DOUBLE PRECISION  V,DATA(30,2),D(450),ONE,ZERO,SUM,
     +   S(10),C(10),SUP,W,PL,PU,DELTAL,Y(10,3)
      INTEGER  G,R,B(11),CFORM
C
      ONE = 1.0D0
      ZERO = 0.0D0
      KZ = 0
      DO 200 I = 1,G
         KZ = KZ+B(I)
  200 CONTINUE
      IF(KZ.GT.N) STOP 'SUM OF GROUP SIZES EXCEEDS TOTAL CASES'
      HEAD = 'EXACT MULTI-RESPONSE PERMUTATION PROCEDURE RESULTS'
      WRITE(7,330) HEAD
  330 FORMAT(T15,A,/)
      WRITE(7,340) N,R,V,G,SUP
  340 FORMAT(T5,'NUMBER OF OBJECTS =',I3,/,T5,'NUMBER OF RESPONSES =',
     +   I3,/,T5,'DISTANCE EXPONENT =',G15.8,/,T5,'NUMBER OF GROUPS =',
     +   I3,/,T5,'UPPER DISTANCE BOUND =',G15.8)
      GO TO (341,342,343,344) CFORM
  341 WRITE(7,346) 'C(I) = n(I)/sum(n(I))'
      GO TO 348
  342 WRITE(7,346) 'C(I) = (n(I)-1)/sum(n(I)-1)'
      GO TO 348
  343 WRITE(7,346) 'C(I) = 1/sum(1)'
      GO TO 348
  344 WRITE(7,346) 'C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))'
  346 FORMAT(T5,A,/)
  348 K = 0
      DO 350 I = 1,G
         WRITE(7,360) I,B(I)
         K = K+B(I)
  350 CONTINUE
  360 FORMAT(T5,'SIZE OF GROUP ',I2,' =',I3)
      B(G+1) = N-K
      DO 370 I = 1,G
         S(I) = ONE*B(I)*(B(I)-1)/2
  370 CONTINUE
      WRITE(7,380) B(G+1)
  380 FORMAT(T5,'SIZE OF EXCESS GROUP =',I3,/)
      GO TO (410,430,450,470) CFORM
  410 DO 420 I = 1,G
         C(I) = ONE*B(I)/K
  420 CONTINUE
      GO TO 500
  430 DO 440 I = 1,G
         C(I) = ONE*(B(I)-1)/(K-G)
  440 CONTINUE
      GO TO 500
  450 DO 460 I = 1,G
         C(I) = ONE/G
  460 CONTINUE
      GO TO 500
  470 W = ZERO
      DO 475 I = 1,G
         W = W+ONE*B(I)*(B(I)-1)
  475 CONTINUE
      DO 480 I = 1,G
         C(I) = ONE*B(I)*(B(I)-1)/W
  480 CONTINUE
  500 L = 1
  565 DO 580 I = 1,N-1
         DO 575 J = I+1,N
            SUM = ZERO
            DO 570 K = 1,R
               SUM = SUM+(DATA(I,K)-DATA(J,K))**2
  570       CONTINUE
            D(L) = SUM**(V/2)
            IF(D(L).GT.SUP) D(L) = SUP
            L = L+1
  575    CONTINUE
  580 CONTINUE
  585 CALL PERM(N,G,B,S,C,D,KOUNT1,KOUNT2,KOUNT3,DELTAL)
      PL = ONE*KOUNT2/KOUNT1
      PU = ONE*KOUNT3/KOUNT1
      WRITE(7,595) DELTAL
  595 FORMAT(T5,'OBSERVED MRPP STATISTIC (d0) =',G15.8)
      WRITE(7,600) KOUNT1
  600 FORMAT(T5,'TOTAL NUMBER OF d VALUES =',I9)
      WRITE(7,605) KOUNT2
  605 FORMAT(T5,'NUMBER OF d VALUES < or = to d0 =',I9)
      WRITE(7,610) KOUNT3
  610 FORMAT(T5,'NUMBER OF d VALUES > or = to d0 =',I9)
      WRITE(7,800) PL
  800 FORMAT(T5,'EXACT LOWER-TAIL MRPP P-VALUE =',G15.8)
      WRITE(7,805) PU
  805 FORMAT(T5,'EXACT UPPER-TAIL MRPP P-VALUE =',G15.8)
      DO 2100 I = 1,G
         WRITE(7,2000) 'LOWER QUARTILE OF GROUP',I,' = ',Y(I,1)
         WRITE(7,2000) 'MEDIAN VALUE OF GROUP  ',I,' = ',Y(I,2)
         WRITE(7,2000) 'UPPER QUARTILE OF GROUP',I,' = ',Y(I,3)
 2000    FORMAT(T10,A,I3,A,G16.8)
 2100 CONTINUE
      WRITE(7,2200)
 2200 FORMAT('********************************************************')
      RETURN
      END
C
C
      SUBROUTINE PERM(N,G,B,S,C,D,KOUNT1,KOUNT2,KOUNT3,DELTAL)
C
      DOUBLE PRECISION  D(450),S(10),C(10),DELTAL,DELTAU
      INTEGER  G,A(11,30),B(11),P(30)
C
      K = G
      IF(B(G+1).NE.0) K = K+1
      L = N
      DO 50 I = 1,K-1
         DO 30 J = 1,B(I)
            A(I,J) = I
   30    CONTINUE
         DO 40 J = B(I)+1,L
            A(I,J) = I+1
   40    CONTINUE
         L = L-B(I)
   50 CONTINUE
      KOUNT1 = 0
      KOUNT2 = 0
      KOUNT3 = 0
   60 I = K-1
      NMARKS = B(K)+B(I)
      IF(KOUNT1.EQ.0) GO TO 130
   70 DO 80 J = 1,NMARKS-1
         IF(A(I,J).EQ.I.AND.A(I,J+1).EQ.I+1) THEN
            LIMIT = J-2
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)-1
            IF(LIMIT.LE.0) GO TO 130
            GO TO 110
         END IF
   80 CONTINUE
      IF(NMARKS.EQ.1) GO TO 100
      DO 90 J = 1,NMARKS/2
         ITEMP = A(I,J)
         A(I,J) = A(I,NMARKS-J+1)
         A(I,NMARKS-J+1) = ITEMP
   90 CONTINUE
  100 I = I-1
      IF(I.EQ.0) RETURN
      NMARKS = NMARKS+B(I)
      GO TO 70
  110 IFLAG = 0
      DO 120 J = 1,LIMIT
         IF(A(I,J).EQ.I+1.AND.A(I,J+1).EQ.I) THEN
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)+1
            IFLAG = 1
         END IF
  120 CONTINUE
      IF(IFLAG.EQ.1) GO TO 110
  130 DO 140 J = 1,N
         A(K,J) = A(1,J)
  140 CONTINUE
      IF(K.EQ.2) GO TO 170
      DO 160 L = 2,K-1
         M = 1
         DO 150 J = 1,N
            IF(A(K,J).EQ.L) THEN
               A(K,J) = A(L,M)
               M = M+1
            END IF
  150    CONTINUE
  160 CONTINUE
  170 LL = 1
      DO 190 II = 1,K
         DO 180 JJ = 1,N
            IF(A(K,JJ).EQ.II) THEN
               P(LL) = JJ
               LL = LL+1
            END IF
  180    CONTINUE
  190 CONTINUE
      CALL DVAL(N,G,B,S,C,D,P,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU)
      KOUNT1 = KOUNT1+1
      GO TO 60
      END
C
C
      SUBROUTINE DVAL(N,G,B,S,C,D,P,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU)
C
      DOUBLE PRECISION  D(450),S(10),C(10),ZERO,ONE,XI(10),DELTA,DELTAL,
     +   DELTAU,PREC
      INTEGER  G,B(11),P(30)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PREC = 1.0D-12
      LL = 0
      DO 30 II = 1,G
         KK = LL+1
         LL = LL+B(II)
         XI(II) = ZERO
         DO 20 III = KK,LL-1
            I = P(III)
            DO 10 JJJ = III+1,LL
               J = P(JJJ)
               K = N*(I-1)+J-(I*(I+1))/2
               XI(II) = XI(II)+D(K)
   10       CONTINUE
   20    CONTINUE
         XI(II) = XI(II)/S(II)
   30 CONTINUE
      DELTA = ZERO
      DO 40 II = 1,G
         DELTA = DELTA+C(II)*XI(II)
   40 CONTINUE
      IF(KOUNT1.EQ.0) THEN
         DELTAL = DELTA*(ONE+PREC)
         DELTAU = DELTA*(ONE-PREC)
      END IF
      IF(DELTA.LT.DELTAL) KOUNT2 = KOUNT2+1
      IF(DELTA.GT.DELTAU) KOUNT3 = KOUNT3+1
      RETURN
      END
