      PROGRAM RCEG
      IMPLICIT REAL*8(A-H,O-Z)
C
C         PROGRAM MODIFIED 11/11/96
C
      CHARACTER  FOUT*40
      DIMENSION  MCELL(10000)
C
      WRITE(*,*) 'ENTER (0,1) FOR (MRPPRC,GKTAU) R BY C TABLE ANALYSES'
      READ(*,*) L
      WRITE(*,*) 'ASSOCIATE ROWS WITH RESPONSES AND COLUMNS WITH GROUPS'
      WRITE(*,*) 'EXCESS GROUP IS COLUMN # NCOL+1, ENTER 0 IF EMPTY'
      WRITE(*,*) 'ENTER  NROW, NCOL'
      READ(*,*) NROW,NCOL
      DO 5 I = 1,NROW
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*)  (MCELL(NROW*(J-1)+I),J = 1,NCOL+1)
    5 CONTINUE
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,10) FOUT
   10 FORMAT(A)
      KZ = NCOL+1
      CALL GKAB(NROW,NCOL,KZ,MCELL,DELB,EDELB,VARB,ZB,TB,GAM1B,PROBB,L)
      ONE = 1.0D0
      RHOB = ONE-DELB/EDELB
      OPEN(4,FILE=FOUT,STATUS='NEW')
      IF(L.EQ.1) THEN
         WRITE(4,15) 'G-K R BY C CONTINGENCY TABLE ANALYSIS (EXCESS)'
      ELSE
         WRITE(4,15) 'MRPP R BY C CONTINGENCY TABLE ANALYSIS (EXCESS)'
      END IF
      WRITE(4,20) DELB, ' = OBSERVED VALUE OF DELTA-B'
      WRITE(4,20) EDELB, ' = EXPECTED VALUE OF DELTA-B'
      WRITE(4,20) VARB, ' = VARIANCE OF DELTA-B'
      WRITE(4,20) RHOB, ' = GENERALIZED AGREEMENT MEASURE RHO-B'
      IF(L.EQ.1) THEN
         WRITE(4,20) TB, ' = ESTIMATED VALUE OF TAU-B'
      END IF
      WRITE(4,20) ZB, ' = OBSERVED STANDARDIZED DELTA-B'
      WRITE(4,20) GAM1B, ' = SKEWNESS OF DELTA-B'
      WRITE(4,25) PROBB, ' = P-VALUE OF OBSERVED DELTA-B'
   15 FORMAT(5(/),T8,A,/)
   20 FORMAT(T5,G15.8,A)
   25 FORMAT(T5,G15.8E3,A,/)
      END
C
C
      SUBROUTINE GKAB(NROW,NCOL,KZ,MCELL,DEL,EDEL,VAR,Z,T,GAM1,PROB,L)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  MCELL(NROW,KZ),ROW(100),COL(100),C(100)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DO 10 I = 1,NROW
       ROW(I) = ZERO
   10 CONTINUE
      DO 20 J = 1,NCOL+1
       COL(J) = ZERO
   20 CONTINUE
      DO 40 I = 1,NROW
       DO 30 J = 1,NCOL+1
        ROW(I) = ROW(I)+ONE*MCELL(I,J)
        COL(J) = COL(J)+ONE*MCELL(I,J)
   30  CONTINUE
   40 CONTINUE
      TOT = ZERO
      DO 50 J = 1,NCOL
       TOT = TOT+COL(J)
   50 CONTINUE
      TOTAL = TOT+COL(NCOL+1)
      IF(TOTAL.LT.5.5D0) STOP 'TOTAL NUMBER OF CASES < 6'
      DO 70 I = 1,NCOL
       IF(L.EQ.1) THEN
        C(I) = (COL(I)-1)/(TOT-NCOL)
       ELSE
        C(I) = COL(I)/TOT
       END IF
   70 CONTINUE
      DEL = ZERO
      DO 90 I = 1,NROW
       DO 80 J = 1,NCOL
        DEL = DEL+((COL(J)-MCELL(I,J))*MCELL(I,J)/(COL(J)*(COL(J)-1)))
     +        *C(J)
   80  CONTINUE
   90 CONTINUE
      R1 = ZERO
      R2 = ZERO
      R3 = ZERO
      DO 110 I = 1,NROW
       R1 = R1+ROW(I)*(TOTAL-ROW(I))
       R2 = R2+ROW(I)*(TOTAL-ROW(I))**2
       R3 = R3+ROW(I)*(TOTAL-ROW(I))**3
  110 CONTINUE
      T = ONE-DEL*TOTAL*(TOTAL-NCOL)/R1
      CALL MRPP(TOTAL,NCOL,COL,C,R1,R2,R3,DEL,EDEL,VAR,Z,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE MRPP(TOTAL,NGRPS,GRP,C,E1,E2,E3,DBAR,D1,VAR,T,
     +     GAM1,PROB)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  GRP(NGRPS),C(NGRPS),Q(6),R(100,6),S(11)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      Q(1) = TOTAL
      DO 2280 I = 2,6
         Q(I) = Q(I-1)*(TOTAL-I+1)
 2280 CONTINUE
      D1 = E1/Q(2)
      D2 = D1
      D3 = (E2-E1)/Q(3)
      D4 = ((E1+2)*E1-E2*4)/Q(4)
      D5 = D1
      D6 = D3
      D7 = (E2*2-TOTAL*E1)/Q(3)
      D8 = D4
      D9 = (E3-(TOTAL+4)*E2+(E1+TOTAL+1)*E1)/Q(4)
      D10 = (E3-E2*3+E1*2)/Q(4)
      D11 = ((E1+TOTAL*4+14)*E2-E3*6-(E1*5+TOTAL*2+4)*E1)/Q(5)
      D12 = (E3*40+((E1+30)*E1+TOTAL*8+16)*E1
     +      -(E1*12+TOTAL*24+64)*E2)/Q(6)
      DO 2300 I = 1,NGRPS
         R(I,1) = GRP(I)
         DO 2290 J = 2,6
            R(I,J) = R(I,J-1)*(GRP(I)-J+1)
 2290    CONTINUE
 2300 CONTINUE
      DO 2310 I = 1,11
         S(I) = ZERO
 2310 CONTINUE
      DO 2340 I = 1,NGRPS
         S(4) = S(4)+C(I)**2/R(I,2)
         S(5) = S(5)+C(I)**2/R(I,1)
         S(6) = S(6)+C(I)**3/R(I,2)**2
         S(7) = S(7)+C(I)**3*R(I,3)/R(I,2)**3
         S(8) = S(8)+C(I)**2*((ONE-C(I))/R(I,2)+C(I)*R(I,4)/R(I,2)**3)
         S(9) = S(9)+C(I)**3*R(I,4)/R(I,2)**3
         S(10) = S(10)+C(I)**2*((ONE-C(I))*R(I,3)/R(I,2)**2+
     1           C(I)*R(I,5)/R(I,2)**3)
         S(11) = S(11)+C(I)*((ONE-C(I))*(ONE-C(I)*2)+C(I)*(ONE-C(I))*
     1           R(I,4)*3/R(I,2)**2+C(I)**2*R(I,6)/R(I,2)**3)
 2340 CONTINUE
      VAR = (S(4)-ONE/Q(2))*(D2-D3*2+D4)*2+(S(5)-ONE/Q(1))*(D3-D4)*4
      STDEV = DSQRT(VAR)
      T = (DBAR-D1)/STDEV
      EDELT3 = S(6)*D5*4+S(7)*(D6*3+D7)*8+S(8)*D8*6+
     1         S(9)*(D9*3+D10)*8+S(10)*D11*12+S(11)*D12
      CUM3 = EDELT3-D1*VAR*3-D1**3
      GAM1 = CUM3/STDEV**3
      CALL PVALUE(T,GAM1,PROB)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
