
      PROGRAM LSD
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80,FIN*40,FOUT*40,RES*40
C
      WRITE(*,1000) '*** PROGRAM LSD ***'
 1000 FORMAT(5(/),T19,A)
      WRITE(*,1100) 'PROGRAM LSD COMPUTES A LEAST SQUARED ',
     +              'DEVIATION REGRESSION ANALYSIS','OF AN ',
     +              'EXISTING DATA SET.  ',
     +              'PRESENT MAXIMUMS FOR M AND N ARE:',
     +              'M = 600 OBSERVATIONS,',
     +              'N = 20 INDEPENDENT VARIABLES.',
     +              'RESULTS OF PROGRAM LSD ARE IN NAMED OUTPUT FILE.',
     +              'NOTE THAT THE DEPENDENT VARIABLE (Y) MUST BE ',
     +              'THE LAST VARIABLE','(THAT IS THE RIGHT-MOST ',
     +              'VARIABLE) IN THE DATA SET.'
 1100 FORMAT(1(/),T2,A,A,/,T2,A,A,A,/,T10,A,/,
     +   T10,A,/,T2,A,/,T2,A,A,/,T2,A,A,/)
 1200 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,1200) FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,1200) FOUT
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESIDUAL DATA'
      READ(*,1200) RES
      WRITE(*,*) 'ENTER OUTPUT HEADING:'
      READ(*,1200) HEAD
      OPEN(4,FILE=FIN)
      OPEN(7,FILE=FOUT,STATUS='NEW')
      CALL LEAST(HEAD,RES)
      STOP 'LSD RESULTS IN NAMED OUTPUT FILE'
      END
C
C
      SUBROUTINE LEAST(HEAD,RES)
      IMPLICIT REAL*8(A-H,O-Z)
C
      CHARACTER  HEAD*80,RES*40
      DIMENSION  A(600,21),X(20),E(600),B(20,20),C(20),Y(600),YH(600),
     +           KP(20),KR(20),KC(20)
C
      ZERO = 0.0D0
      ND =  20
      READ(4,*) M,N
      READ(4,*) ((A(I,J),J = 1,N+1),I = 1,M)
      CLOSE(4)
      DO 100 I = 1,M
         Y(I) = A(I,N+1)
  100 CONTINUE
      DO 300 I = 1,N
         C(I) = ZERO
         DO 200 K  = 1,M
            C(I) = C(I)+Y(K)*A(K,I)
  200    CONTINUE
  300 CONTINUE
      DO 600 I = 1,N
         DO 500 J = I,N
            B(I,J) = ZERO
            DO 400 K = 1,M
               B(I,J) = B(I,J)+A(K,I)*A(K,J)
  400       CONTINUE
            B(J,I) = B(I,J)
  500    CONTINUE
  600 CONTINUE
C
      CALL INVERT(N,B,KP,KR,KC,ND)
C
      DO 800 I = 1,N
         X(I) = ZERO
         DO 700 J = 1,N
            X(I) = X(I)+C(J)*B(I,J)
  700    CONTINUE
  800 CONTINUE
      WRITE(7,1100)
 1100 FORMAT(T25,'*** OUTPUT OF LSD ANALYSIS ***',2(/))
      WRITE(7,1200) HEAD
 1200  FORMAT(T5,'HEADING:  ',A,/)
      DO 1700 I = 1,N
         WRITE(7,1600) 'LSD REGRESSION COEFFICIENT',I,' = ',X(I)
 1600    FORMAT(T5,A,I2,A,G15.8)
 1700 CONTINUE
      WRITE(7,2000) M,N
 2000 FORMAT(/,T5,'TOTAL OBSERVATIONS = ',I3,/,T5,'INDEPENDENT',
     +   ' VARIABLES = ',I2,/)
      CO = ZERO
      COO = ZERO
      CP = ZERO
      CPP = ZERO
      COP = ZERO
      DO 2300 I = 1,M
         YH(I) = ZERO
         DO 2200 J = 1,N
            YH(I) = YH(I)+X(J)*A(I,J)
 2200    CONTINUE
         CO = CO+Y(I)
         COO = COO+Y(I)**2
         CP = CP+YH(I)
         CPP = CPP+YH(I)**2
         COP = COP+Y(I)*YH(I)
         E(I) = Y(I)-YH(I)
 2300 CONTINUE
      R = (COP*M-CO*CP)/DSQRT((COO*M-CO*CO)*(CPP*M-CP*CP))
      RR = R*R
      WRITE(7,2400) 'PEARSON CORRELATION COEFFICIENT = ',R
 2400 FORMAT(T5,A,G15.8)
      WRITE(7,2400) 'SQUARED CORRELATION COEFFICIENT = ',RR
C
      WRITE(7,2500) 'CASE','Y-VALUES','Y-HAT VALUES','RESIDUALS'
 2500 FORMAT(/,T5,A,T20,A,T40,A,T63,A,/)
      DO 2700 I = 1,M
         WRITE(7,2600) I,Y(I),YH(I),E(I)
 2600 FORMAT(T5,I3,3(8X,E14.7))
 2700 CONTINUE
C
      OPEN(8,FILE=RES,STATUS='NEW')
      DO 2800 I = 1,M
         WRITE(8,*) E(I)
 2800 CONTINUE
      CLOSE(8)
C
      WRITE(7,2900)
 2900 FORMAT(2(/),T26,'*** END OF LSD ANALYSIS ***')
      RETURN
      END
C
C
      SUBROUTINE INVERT(N,W,KP,KR,KC,ND)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  KP(N),KR(N),KC(N),W(ND,N)
C
      ZERO = 0.0D0
      DO 5 I = 1,N
         KP(I) = 0
    5 CONTINUE
      DO 45 I = 1,N
         T = ZERO
         DO 20 J = 1,N
            IF(KP(J).NE.1) THEN
               DO 15 K = 1,N
                  IF(KP(K)-1) 10,15,60
   10             IF(T.LT.DABS(W(J,K))) THEN
                     IR = J
                     IC = K
                     T = DABS(W(J,K))
                  END IF
   15          CONTINUE
            END IF
   20    CONTINUE
         KP(IC) = KP(IC)+1
         IF(IR.NE.IC) THEN
            DO 25 L = 1,N
               T = W(IR,L)
               W(IR,L) = W(IC,L)
               W(IC,L) = T
   25       CONTINUE
         END IF
         KR(I) = IR
         KC(I) = IC
         T = W(IC,IC)
         W(IC,IC) = 1.0D0
         DO 30 L = 1,N
            W(IC,L) = W(IC,L)/T
   30    CONTINUE
         DO 40 M = 1,N
            IF(M.NE.IC) THEN
               T = W(M,IC)
               W(M,IC) = ZERO
               DO 35 L = 1,N
                  W(M,L) = W(M,L)-W(IC,L)*T
   35          CONTINUE
            END IF
   40    CONTINUE
   45 CONTINUE
      DO 55 I = 1,N
         J = N-I+1
         IF(KR(J).NE.KC(J)) THEN
            K = KR(J)
            L = KC(J)
            DO 50 M = 1,N
               T = W(M,K)
               W(M,K) = W(M,L)
               W(M,L) = T
   50       CONTINUE
         END IF
   55 CONTINUE
   60 RETURN
      END
