      PROGRAM PTMP
C
C         PERMUTATION TEST FOR MATCHED PAIRS (PTMP) YIELDS EITHER
C         EXACT (N = 3,...,LC) OR APPROXIMATE (N = LC+1,...,100)
C         P-VALUES (POWER OF RANKS TEST IS INCLUDED AS A SPECIAL
C         CASE).  IF N GREATER THAN 30, THEN THE P-VALUE WILL BE
C         APPROXIMATE.  AN OPTION OF THIS PROGRAM IS THE ONE-SAMPLE
C         TEST.  THIS PROGRAM IS CAPABLE OF MULTIPLE RUNS.
C
C         PROGRAM MODIFIED 12/10/98
C
      DOUBLE PRECISION  ZERO,ONE,FN,V,D(300,2),DIFF,X(100),Y(100),
     +   R(100),A(100,100),B(100,100),PHI,W,H,A1,A2,A3,A4,B1,B2,
     +   SUM,AS,BS,CS,DELTA1,EDELTA,VAR,T,GAM,PROB,RHO,ZM
      CHARACTER  FIN*40,FOUT*40,HEAD*80
      INTEGER  OLDN,TEST
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*) 'ENTER: FILE NAME OF INPUT DATA'
      READ(*,3) FIN
    3 FORMAT(A)
      WRITE(*,*) 'ENTER: FILE NAME FOR OUTPUT RESULTS'
      READ(*,3) FOUT
      OPEN(1,FILE=FIN)
      OPEN(2,FILE=FOUT,STATUS='NEW')
    5 READ(1,3,END=7) HEAD
      GO TO 10
    7 GO TO 200
   10 READ(1,*) V,OLDN,LC,KM,ZM,LR,H
      IF(KM.EQ.2) GO TO 13
      READ(1,*) (D(I,1),I=1,OLDN)
      DO 12 I = 1,OLDN
         D(I,1) = D(I,1)-ZM
         D(I,2) = ZERO-D(I,1)
   12 CONTINUE
      GO TO 14
   13 READ(1,*) ((D(I,J),J = 1,2),I = 1,OLDN)
   14 N = 0
      DO 15 I = 1,OLDN
         DIFF = D(I,1)-D(I,2)
         IF(DIFF.NE.ZERO) THEN
            N = N+1
            X(N) = DIFF
         END IF
   15 CONTINUE
      IF(N.LT.3) THEN
         WRITE(*,*) 'N LESS THAN THREE'
         GO TO 200
      END IF
      IF(LR.NE.1) GO TO 25
      DO 17 I = 1,N
         Y(I) = DABS(X(I))
   17 CONTINUE
      PHI = ONE+1.0D-12
      A1 = ZERO
      A2 = ZERO
      A3 = ONE*N-0.1D0
      B1 = ZERO
      B2 = 1.0D30
   18 IF(A2.GT.A3) GO TO 22
      DO 19 I = 1,N
         IF(Y(I).GT.B1.AND.Y(I).LT.B2) B2 = Y(I)*PHI
   19 CONTINUE
      DO 20 I = 1,N
         W = DABS(ONE-Y(I)/B2)
         IF(W.LT.1.0D-11) A1 = A1+1
   20 CONTINUE
      A4 = A2+(A1+1)/2
      DO 21 I = 1,N
         W = DABS(ONE-Y(I)/B2)
         IF(W.LT.1.0D-11) R(I) = A4
   21 CONTINUE
      A2 = A2+A1
      A1 = ZERO
      B1 = B2
      B2 = 1.0D30
      GO TO 18
   22 DO 23 I = 1,N
         X(I) = (X(I)/Y(I))*R(I)**H
   23 CONTINUE
   25 FN = ONE*N
      TEST = 1
      IF(N.LE.LC) TEST = 2
      IF(N.GT.30) TEST = 1
      IF(TEST.EQ.2) THEN
         CALL COMB(N,FN,V,X,DELTA1,PROB)
         GO TO 93
      END IF
      SUM = ZERO
      DO 35 I = 1,N-1
         DO 30 J = I+1,N
            SUM = SUM+(DABS(X(I)-X(J)))**V
   30    CONTINUE
   35 CONTINUE
      DELTA1 = SUM*2/(FN*(FN-1))
      DO 40 I = 1,N
         X(I) = DABS(X(I))
   40 CONTINUE
      AS = ZERO
      BS = ZERO
      CS = ZERO
      DO 60 I = 1,N-1
         DO 50 J = I+1,N
            A(I,J) = (X(I)+X(J))**V
            B(I,J) = (DABS(X(I)-X(J)))**V
            AS = AS+(A(I,J)+B(I,J))
            BS = BS+(A(I,J)-B(I,J))*(A(I,J)-B(I,J))
   50    CONTINUE
   60 CONTINUE
      DO 90 I = 1,N-2
         DO 80 J = I+1,N-1
            DO 70 K = J+1,N
               CS = CS+(A(I,J)-B(I,J))*(A(I,K)-B(I,K))*(A(J,K)-B(J,K))
   70       CONTINUE
   80    CONTINUE
   90 CONTINUE
      EDELTA = AS/(FN*(FN-1))
      RHO = ONE-DELTA1/EDELTA
      VAR = BS/(FN*FN*(FN-1)*(FN-1))
      T = (DELTA1-EDELTA)/DSQRT(VAR)
      GAM = -CS*6/(BS*DSQRT(BS))
      CALL PVALUE(T,GAM,PROB)
   93 WRITE(2,3) HEAD
      WRITE(2,95) 'RESULTS OF PTMP ANALYSIS'
   95 FORMAT(T24,A,/)
      IF(KM.EQ.1) THEN
         WRITE(2,97) 'PTMP IS A ONE-SAMPLE TEST'
         WRITE(2,110) 'THE HYPOTHESIZED CENTER VALUE =', ZM
      ELSE
         WRITE(2,97) 'PTMP IS A MATCHED-PAIRS TEST'
      END IF
   97 FORMAT(T15,A)
      WRITE(2,3) ' '
      IF(TEST.EQ.2) GO TO 100
      WRITE(2,110) 'EXPECTED DELTA =', EDELTA
      WRITE(2,110) 'VARIANCE OF DELTA =', VAR
      WRITE(2,110) 'SKEWNESS OF DELTA =', GAM
      WRITE(2,110) 'OBSERVED STANDARDIZED STATISTIC =', T
      WRITE(2,110) 'MEASURE OF AGREEMENT =', RHO
  100 WRITE(2,110) 'OBSERVED DELTA =', DELTA1
      WRITE(2,110) 'DISTANCE EXPONENT =', V
      IF(LR.NE.1) GO TO 105
      WRITE(2,110) 'EXPONENT FOR POWER OF RANKS TEST =', H
  105 IF(TEST.EQ.2) THEN
         WRITE(2,97) 'P-VALUE IS EXACT.'
      ELSE
         WRITE(2,97) 'P-VALUE IS APPROXIMATE.'
      END IF
      WRITE(2,110) 'P-VALUE OF A SMALLER OR EQUAL DELTA =', PROB
  110 FORMAT(T10,A,G20.8)
      WRITE(2,3) ' '
      WRITE(2,120) 'NUMBER OF VALUES OR PAIRS =', OLDN
      WRITE(2,120) 'NUMBER OF NON-ZERO VALUES OR DIFFERENCES =', N
  120 FORMAT(T10,A,I4)
      WRITE(2,130)
  130 FORMAT('********************************************************')
      GO TO 5
  200 CLOSE(1)
      CLOSE(2)
      END
C
C
      SUBROUTINE COMB(N,FN,V,X,DELTA1,PROB)
C
      DOUBLE PRECISION  FN,V,X(100),DELTA1,PROB,ONE
      INTEGER  M(30)
C
      ONE = 1.0D0
      DO 10 I = 1,N
         M(I) = 1
   10 CONTINUE
      KOUNT1 = 0
      KOUNT2 = 0
      KOUNT3 = 0
      NMINUS = 0
      LAST = 0
      GO TO 50
   20 J = 0
   30 J = J+1
      IF(MOD(KOUNT3,2).EQ.1) GO TO 40
      KOUNT3 = KOUNT3/2
      GO TO 30
   40 LAST = M(J)
      M(J) = -LAST
   50 KOUNT1 = KOUNT1+1
      KOUNT3 = KOUNT1
      NMINUS = NMINUS+LAST
      CALL XACT(N,FN,V,X,M,KOUNT1,KOUNT2,DELTA1)
      IF(NMINUS.EQ.1.AND.M(N).EQ.-1) GO TO 60
      GO TO 20
   60 PROB = ONE*KOUNT2/KOUNT1
      RETURN
      END
C
C
      SUBROUTINE XACT(N,FN,V,X,M,KOUNT1,KOUNT2,DELTA1)
C
      DOUBLE PRECISION  FN,V,X(100),DELTA1,ZERO,ONE,PREC,SUM,DELTA
      INTEGER  M(30)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PREC = 1.0D-12
      SUM = ZERO
      DO 20 I = 1,N-1
         DO 10 J = I+1,N
            SUM = SUM+(DABS(X(I)*M(I)-X(J)*M(J)))**V
   10    CONTINUE
   20 CONTINUE
      DELTA = SUM*2/(FN*(FN-1))
      IF(KOUNT1.EQ.1) DELTA1 = DELTA*(ONE+PREC)
      IF(DELTA.LE.DELTA1) KOUNT2 = KOUNT2+1
      RETURN
      END
C
C
      SUBROUTINE PVALUE(T,GAM,PROB)
C
C         SUBROUTINE PVALUE CALCULATES THE PROBABILITY THAT A VALUE OF
C         T IS LESS THAN OR EQUAL TO THE OBSERVED VALUE OF T.
C
      DOUBLE PRECISION  T,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H1N,H2,H3
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      F = R*R+10
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +        -ONE/(F*F*F*360)
      A = R*R-1
      B = R*R*(DLOG(R)-1)-U
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      W = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(T.LT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = T
      Y = T+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(2*I-1))-R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      PROB = ONE-G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   30 IF(T.GT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = T-15
      Y = T
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(2*I-1))+R*(X+G1*(2*I-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H1N = E(G)
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      PROB = G3*(H0+(H1+H1N)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -T*T/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(T)
      IF(U.GT.A) GO TO 60
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*U+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(T.GT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
