      PROGRAM GSECT
      IMPLICIT REAL*8(A-H,O-Z)
C
C                  G-SAMPLE EMPIRICAL COVERAGE TEST FOR V > 0
C            M(1),...,M(G) ARE G SAMPLE SIZES AND N = M(1)+...+M(G)
C  DATA IS ASSUMED TO CONSIST OF CONTINUOUS UNIVARIATE OBSERVATIONS (NO TIES).
C
      CHARACTER FIN*40,FOUT*40
      DIMENSION U(17),M(25),Y(500),R(500),X(200,25),C(201,25)
C
C  IF G > 25, N > 500 OR AN M(I) > 200, REVISE THE ABOVE DIMENSION STATEMENT.
C
      ZERO = 0.0D0
      ONE = 1.0D0
      EPSLN = 1.0D-12
      WRITE(*,*) 'ENTER FILE NAME OF INPUT DATA'
      READ(*,'(A)') FIN
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,'(A)') FOUT
      WRITE(*,*) 'ENTER V, G, M(1),...,M(G)'
      READ(*,*) V,NG,(M(I),I=1,NG)
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,NS
      IF(NG.LT.2) THEN
         WRITE(*,*) 'PROGRAM TERMINATED SINCE G IS LESS THAN 2'
         GO TO 300
      ENDIF
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 5 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 4 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    4    CONTINUE
         U(II) = S
    5 CONTINUE
      N = 0
      DO 10 I = 1,NG
         N = N+M(I)
   10 CONTINUE
      OPEN(5,FILE=FIN)
      READ(5,*) (Y(I),I = 1,N)
      CLOSE(5)
      A1 = ZERO
      A2 = ZERO
      A3 = ONE*N-0.1D0
      B1 = -1.0D30
      B2 = 1.0D30
   13 IF(A2.GT.A3) GO TO 17
      DO 14 I = 1,N
         IF(Y(I).GT.B1.AND.Y(I).LT.B2) B2 = Y(I)+1.0D-8
   14 CONTINUE
      DO 15 I = 1,N
         W = DABS(Y(I)-B2)
         IF(W.LT.1.0D-7) A1 = A1+1
   15 CONTINUE
      A4 = A2+(A1+1)/2
      DO 16 I = 1,N
         W = DABS(Y(I)-B2)
         IF(W.LT.1.0D-7) R(I) = A4
   16 CONTINUE
      A2 = A2+A1
      A1 = ZERO
      B1 = B2
      B2 = 1.0D30
      GO TO 13
   17 K = 0
      DO 19 I = 1,NG
         DO 18 J = 1,M(I)
            K = K+1
            X(J,I) = R(K)
   18    CONTINUE
   19 CONTINUE
      DO 30 I = 1,NG
         J = M(I)
         K = J/2+1
   21    K = K-1
         W = X(K,I)
         GO TO 23
   22    W = X(J,I)
         X(J,I) = X(1,I)
         J = J-1
   23    II = K
   24    L = 2*II
         IF(L-J) 25,26,27
   25    IF(X(L+1,I).GE.X(L,I)) L = L+1
   26    IF(W.GE.X(L,I)) GO TO 27
         X(II,I) = X(L,I)
         II = L
         GO TO 24
   27    X(II,I) = W
         IF(K.GT.1) GO TO 21
         IF(J.GE.2) GO TO 22
   30 CONTINUE
      DO 40 I = 1,NG
         DO 39 J = 1,M(I)+1
            IF(J.EQ.1) THEN
               C(J,I) = X(J,I)/(N+1)
            ELSEIF(J.EQ.M(I)+1) THEN
               C(J,I) = ONE-X(J-1,I)/(N+1)
            ELSE
               C(J,I) = (X(J,I)-X(J-1,I))/(N+1)
            ENDIF
   39    CONTINUE
   40 CONTINUE
      ET = ZERO
      DO 70 I = 1,NG
         D = ZERO
         DO 60 J = 1,N-M(I)+1
            D = D+DABS(ONE*J/(N+1)-ONE/(M(I)+1))**V*COMB(N-J,M(I)-1)
   60    CONTINUE
         ET = ET+D*(M(I)+1)/COMB(N,M(I))
   70 CONTINUE
      TO = ZERO
      DO 90 I = 1,NG
         DO 89 J = 1,M(I)+1
            TO = TO+DABS(C(J,I)-ONE/(M(I)+1))**V
   89    CONTINUE
   90 CONTINUE
      TO = TO*(ONE-EPSLN)
      MZ = 0
      VT = ZERO
      SKT = ZERO
      ED2 = ZERO
      DO 200 IS = 1,NS
         CALL SAMPWOR(N,N,U,R)
         N1 = 0
         DO 108 I = 1,NG
            DO 107 J = 1,M(I)
               N1 = N1+1
               X(J,I) = R(N1)
  107       CONTINUE
  108    CONTINUE
         DO 120 I = 1,NG
            J = M(I)
            K = J/2+1
  111       K = K-1
            W = X(K,I)
            GO TO 113
  112       W = X(J,I)
            X(J,I) = X(1,I)
            J = J-1
  113       II = K
  114       L = 2*II
            IF(L-J) 115,116,117
  115       IF(X(L+1,I).GE.X(L,I)) L = L+1
  116       IF(W.GE.X(L,I)) GO TO 117
            X(II,I) = X(L,I)
            II = L
            GO TO 114
  117       X(II,I) = W
            IF(K.GT.1) GO TO 111
            IF(J.GE.2) GO TO 112
  120    CONTINUE
         DO 140 I = 1,NG
            DO 139 J = 1,M(I)+1
               IF(J.EQ.1) THEN
                  C(J,I) = X(J,I)/(N+1)
               ELSEIF(J.EQ.M(I)+1) THEN
                  C(J,I) = ONE-X(J-1,I)/(N+1)
               ELSE
                  C(J,I) = X(J,I)/(N+1)-X(J-1,I)/(N+1)
               ENDIF
  139       CONTINUE
  140    CONTINUE
         T = ZERO
         DO 190 I = 1,NG
            DO 189 J = 1,M(I)+1
               T = T+DABS(C(J,I)-ONE/(M(I)+1))**V
  189       CONTINUE
  190    CONTINUE
         VT = VT+(T-ET)**2
         SKT = SKT+(T-ET)**3
         ED2 = ED2+(T-ET)**4
         IF(T.GT.TO) MZ = MZ+1
  200 CONTINUE
      SDVT = DSQRT((ED2*NS-VT*VT)/(ONE*NS*NS*(NS-1)))
      VT = VT/NS
      SKT = (SKT/NS)/VT**1.5D0
      Z = (TO-ET)/DSQRT(VT)
      PZ = ONE*MZ/NS
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,230) 'G-SAMPLE EMPIRICAL COVERAGE TEST RESULTS'
  230 FORMAT(/,T18,A,/)
      WRITE(6,250) 'TOTAL # OF OBSERVED VALUES = ',N
  250 FORMAT(T3,A,I9)
      WRITE(6,250) 'RANDOM # GENERATOR SEED = ',ISEED
      WRITE(6,250) '# OF SIMULATIONS = ',NS
      WRITE(6,260) 'THE COVERAGE EXPONENT = ',V
  260 FORMAT(T3,A,G16.8)
      WRITE(6,270) 'THERE ARE ',NG,' GROUPS OF SIZES',(M(I),I = 1,NG)
  270 FORMAT(T3,A,I3,A,10I4)
      WRITE(6,280) 'OBSERVED GSECT STATISTIC = ',TO
  280 FORMAT(/,T6,A,G16.8)
      WRITE(6,290) 'MEAN OF GSECT STATISTIC = ',ET
  290 FORMAT(T6,A,G16.8)
      WRITE(6,290) 'ESTIMATED VARIANCE OF GSECT STATISTIC = ',VT
      WRITE(6,290) 'STANDARD DEVIATION OF ESTIMATED VARIANCE = ',SDVT
      WRITE(6,290) 'OBSERVED STANDARDIZED GSECT STATISTIC = ',Z
      WRITE(6,290) 'ESTIMATED SKEWNESS OF GSECT STATISTIC = ',SKT
      CALL PVALUE(Z,SKT,PVAL)
      WRITE(6,290) 'P-VALUE OF OBSERVED GSECT STATISTIC = ',PVAL
      WRITE(6,290) 'BOOTSTRAP P-VALUE OF OBSERVED GSECT STATISTIC = ',PZ
      CLOSE(6)
  300 END
C
C
      DOUBLE PRECISION FUNCTION COMB(N,M)
C
      DOUBLE PRECISION  ONE,PI,R,Z,D,F,U1,U2,U3
C
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      COMB = DEXP(U1-U2-U3)
      RETURN
      END
C
C
      SUBROUTINE SAMPWOR(M,N,U,X)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  U(17),X(500)
C
C     M: SIZE OF POPULATION
C     N: SIZE OF SAMPLE DRAWN WITHOUT REPLACEMENT (1 </= N </= M)
C     X: REAL INPUT WHICH CONTAINS X(1),...,X(M) POPULATION VALUES
C     WITHOUT REPLACEMENT SAMPLE CONTAINED IN X(1),...,X(N)
C
C     UNI(U) IS UNIFORM RANDOM NUMBER GENERATOR ON (0,1)
C
      DO 10 I = 1,N
         J = INT(I+(M-I+1)*UNI(U))
         BIN = X(J)
         X(J) = X(I)
         X(I) = BIN
   10 CONTINUE
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C
C
      SUBROUTINE PVALUE(Z,GAM,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE
C        OF Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE
C        OF Z.
C
      DOUBLE PRECISION  Z,GAM,PROB,ONE,ZERO,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H2,H3,H4
C
      ONE = 1.0D0
      ZERO = 0.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      F = R*R+10
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)-
     +    ONE/(F*F*F*360)
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      A  = R*R-1
      B  = R*R*(DLOG(R)-1)-U
      W  = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(Z.LT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = Z
      Y = Z+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(I*2-1))-R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H4 = E(G)
      PROB = G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   30 IF(Z.GT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = Z-15
      Y = Z
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(I*2-1))+R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H4 = E(G)
      PROB = ONE-G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 70
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 60
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
