      PROGRAM DRIVER
      IMPLICIT REAL*8(A-H,O-Z)
C
C  THIS PROGRAM WILL CALCULATE THE INVERSE MATRIX FOR ANY SQUARE
C  ASYMMETRIC NONSINGULAR MATRIX.  PRINTING RESTRICTIONS CONSTRAIN
C  RESULTS TO 6 BY 6 OR SMALLER SQUARE MATRICES.  IF THIS PRINTING
C  RESTRICTION IS RELAXED, THEN THE PRESENT PROGRAM WILL HANDLE SQUARE
C  MATRICES UP TO 20 BY 20 AND THIS CAN BE MADE MUCH LARGER BY MERELY
C  ADJUSTING THE FOLLOWING DIMENSION STATEMENT AND THE VALUE OF ND
C  BELOW THIS STATEMENT.
C
      DIMENSION  KP(20),KR(20),KC(20),W(20,20)
C
      ND = 20
      WRITE(*,*) 'ENTER ORDER OF MATRIX'
      READ(*,*) N
      DO 100 I = 1,N
         WRITE(*,*) 'ENTER ROW ', I, ' OF THE MATRIX'
         READ(*,*) (W(I,J),J=1,N)
  100 CONTINUE
      DO 120 I = 1,N
         WRITE(*,110) (W(I,J),J=1,N)
  110    FORMAT(/,6F13.6)
  120 CONTINUE
C
      CALL INVERT(N,W,KP,KR,KC,ND)
C
      WRITE(*,130)
  130 FORMAT(/)
      DO 140 I = 1,N
         WRITE(*,110) (W(I,J),J=1,N)
  140 CONTINUE
      END
C
C
      SUBROUTINE INVERT(N,W,KP,KR,KC,ND)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  KP(N),KR(N),KC(N),W(ND,N)
C
      ZERO = 0.0D0
      DO 5 I = 1,N
         KP(I) = 0
    5 CONTINUE
      DO 45 I = 1,N
         T = ZERO
         DO 20 J = 1,N
            IF(KP(J).NE.1) THEN
               DO 15 K = 1,N
                  IF(KP(K)-1) 10,15,60
   10             IF(T.LT.DABS(W(J,K))) THEN
                     IR = J
                     IC = K
                     T = DABS(W(J,K))
                  END IF
   15          CONTINUE
            END IF
   20    CONTINUE
         KP(IC) = KP(IC)+1
         IF(IR.NE.IC) THEN
            DO 25 L = 1,N
               T = W(IR,L)
               W(IR,L) = W(IC,L)
               W(IC,L) = T
   25       CONTINUE
         END IF
         KR(I) = IR
         KC(I) = IC
         T = W(IC,IC)
         W(IC,IC) = 1.0D0
         DO 30 L = 1,N
            W(IC,L) = W(IC,L)/T
   30    CONTINUE
         DO 40 M = 1,N
            IF(M.NE.IC) THEN
               T = W(M,IC)
               W(M,IC) = ZERO
               DO 35 L = 1,N
                  W(M,L) = W(M,L)-W(IC,L)*T
   35          CONTINUE
            END IF
   40    CONTINUE
   45 CONTINUE
      DO 55 I = 1,N
         J = N-I+1
         IF(KR(J).NE.KC(J)) THEN
            K = KR(J)
            L = KC(J)
            DO 50 M = 1,N
               T = W(M,K)
               W(M,K) = W(M,L)
               W(M,L) = T
   50       CONTINUE
         END IF
   55 CONTINUE
   60 RETURN
      END
