      PROGRAM S2W
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 3/27/2008
C
      CHARACTER  FOUT*40
      DIMENSION  U(17),MM1(20),MM2(20),L(20,20)
C
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,*) 'ENTER # IN ARRAY 1 (ROWS) AND # IN ARRAY 2 (COLUMNS):'
      READ(*,*) N1,N2
      DO 2 I = 1,N1
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*) (L(I,J),J = 1,N2)
    2 CONTINUE
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
C
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 4 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 3 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    3    CONTINUE
         U(II) = S
    4 CONTINUE
C
      IT = 0
      PSTART = 0.0D0
      DO 6 I = 1,N1
         MM1(I) = 0
         DO 5 J = 1,N2
            MM1(I) = MM1(I)+L(I,J)
    5    CONTINUE
         IT = IT+MM1(I)
         PSTART = PSTART+FAC(MM1(I))
    6 CONTINUE
      DO 8 J = 1,N2
         MM2(J) = 0
         DO 7 I = 1,N1
            MM2(J) = MM2(J)+L(I,J)
    7    CONTINUE
         PSTART = PSTART+FAC(MM2(J))
    8 CONTINUE
      PSTART = PSTART-FAC(IT)
      CR = RZ(IT)
      DO 9 I = 1,N1
         CR = CR-RZ(MM1(I))
    9 CONTINUE
      DO 10 J = 1,N2
         CR = CR-RZ(MM2(J))
   10 CONTINUE
C  DETERMINE THE PROBABILITY OF THE OBSERVED TABLE.
      CELLFAC = 0.0D0
      CS = 0.0D0
      CZ = 0.0D0
      CL = 0.0D0
      DO 12 I = 1,N1
         DO 11 J = 1,N2
            CELLFAC = CELLFAC+FAC(L(I,J))
            CS = CS+(1.0D0*L(I,J))**2/MM1(I)/MM2(J)
            CZ = CZ+1.0D0*L(I,J)*(L(I,J)-1)/MM1(I)/MM2(J)
            CL = CL+RZ(L(I,J))
   11    CONTINUE
   12 CONTINUE
      THISP = (PSTART-CELLFAC)*(1.0D0-1.0D-12)
      FEP = DEXP(THISP)
      CST = (CS-1.0D0)*IT*(1.0D0-1.0D-12)
      IF(CST.LT.1.0D-11) CST = -1.0D-11
      CZT = ((CZ-1.0D0)*IT+N1*N2)*(1.0D0-1.0D-12)
      IF(CZT.LT.1.0D-11) CZT = -1.0D-11
      CLT = (CL+CR)*2*(1.0D0-1.0D-12)
      IF(DABS(CLT).LT.1.0D-12) CLT = -1.0D-12
C
      IFE = 0
      ICS = 0
      ICZ = 0
      ICL = 0
C
      DO 30 IS = 1,MS
         CALL XCONT2(IT,N1,N2,CF,CS,CZ,CL,CR,U,MM1,MM2)
         CP = PSTART-CF
         IF(CP.LT.THISP) IFE = IFE+1
         IF(CS.GT.CST) ICS = ICS+1
         IF(CZ.GT.CZT) ICZ = ICZ+1
         IF(CL.GT.CLT) ICL = ICL+1
   30 CONTINUE
C
      PFE = 1.0D0*IFE/MS
      PCS = 1.0D0*ICS/MS
      PCZ = 1.0D0*ICZ/MS
      PCL = 1.0D0*ICL/MS
C
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,40) 'TWO-WAY CONTINGENCY TABLE ANALYSES OF SIZE ',
     +          N1,' & ',N2,' FOR ARRAYS 1 & 2'
      WRITE(6,45) ISEED, ' = RANDOM NUMBER GENERATOR SEED'
      WRITE(6,45) MS, ' = NUMBER OF RANDOM TABLES GENERATED'
      WRITE(6,50) FEP, ' = PROBABILITY OF OBSERVED 2-WAY TABLE'
      WRITE(6,50) PFE, ' = SIMULATED FISHER''S EXACT TEST P-VALUE'
      IF(CST.LE.0.0D0) CST = 0.0D0
      WRITE(6,50) CST, ' = OBSERVED 2-WAY CHI-SQUARE STATISTIC T'
      WRITE(6,50) PCS, ' = SIMULATED CHI-SQUARE TEST P-VALUE'
      IF(CZT.LE.0.0D0) CZT = 0.0D0
      WRITE(6,50) CZT, ' = OBSERVED 2-WAY ZELTERMAN STATISTIC'
      WRITE(6,50) PCZ, ' = SIMULATED ZELTERMAN TEST P-VALUE'
      IF(CLT.LE.0.0D0) CLT = 0.0D0
      WRITE(6,50) CLT, ' = OBSERVED 2-WAY LIKELIHOOD-RATIO STATISTIC'
      WRITE(6,50) PCL, ' = SIMULATED LIKELIHOOD-RATIO TEST P-VALUE'
   40 FORMAT(T2,A,I2,A,I2,A,/)
   45 FORMAT(T5,I10,A)
   50 FORMAT(T5,G15.8,A)
      END
C
C
      SUBROUTINE XCONT2(NT,N1,N2,CF,CS,CZ,CL,CR,U,MM1,MM2)
      IMPLICIT REAL*8(A-H,O-Z)
C
C    GENERATES RANDOM TWO-WAY TABLE WITH FIXED MARGINAL TOTALS
C
      DIMENSION  U(17),L1(20),L2(20),MM1(20),MM2(20),P1(20),P2(20),
     +           W1(20),W2(20),MC(20,20)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      LT = NT
      DO 1 I = 1,N1
         L1(I) = MM1(I)
    1 CONTINUE
      DO 2 I = 1,N2
         L2(I) = MM2(I)
    2 CONTINUE
      DO 4 I = 1,N1
         DO 3 J = 1,N2
            MC(I,J) = 0
    3    CONTINUE
    4 CONTINUE
C
      DO 100 K = 1,NT
C
         DO 25 I = 1,N1
            P1(I) = ONE*L1(I)/LT
   25    CONTINUE
         W1(1) = P1(1)
         DO 20 I = 2,N1-1
            W1(I) = W1(I-1)+P1(I)
   20    CONTINUE
         W1(N1) = ONE
C
         DO 45 I = 1,N2
            P2(I) = ONE*L2(I)/LT
   45    CONTINUE
         W2(1) = P2(1)
         DO 40 I = 2,N2-1
            W2(I) = W2(I-1)+P2(I)
   40    CONTINUE
         W2(N2) = ONE
C
         Z = UNI(U)
         DO 50 I = 1,N1
            IF(Z.LE.W1(I)) THEN
               L1(I) = L1(I)-1
               I1 = I
               GO TO 55
            END IF
   50    CONTINUE
C
   55    Z = UNI(U)
         DO 60 I = 1,N2
            IF(Z.LE.W2(I)) THEN
               L2(I) = L2(I)-1
               I2 = I
               GO TO 65
            END IF
   60    CONTINUE
C
   65    LT = LT-1
         MC(I1,I2) = MC(I1,I2)+1
  100 CONTINUE
C
      CF = ZERO
      CS = ZERO
      CZ = ZERO
      CL = ZERO
      DO 220 I = 1,N1
        DO 219 J = 1,N2
          CF = CF+FAC(MC(I,J))
          CS = CS+(ONE*MC(I,J))**2/MM1(I)/MM2(J)
          CZ = CZ+ONE*MC(I,J)*(MC(I,J)-1)/MM1(I)/MM2(J)
          CL = CL+RZ(MC(I,J))
  219   CONTINUE
  220 CONTINUE
      CS = (CS-ONE)*NT
      CZ = (CZ-ONE)*NT+N1*N2
      CL = (CL+CR)*2
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(5000)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C  FIND I(LOG(I))
      DOUBLE PRECISION X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
