      PROGRAM YECPV
C
C  THE PRESENT MAXIMUM VALUE OF M FOR EDGINGTON'S COMBINED P-VALUE FOR M
C  INDEPENDENT P-VALUES IS M = 50.
C
      DOUBLE PRECISION ZERO,ONE,S,PC,COMB,FAC,Q(50)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*) 'EDGINGTON COMBINED P-VALUE FOR M INDEPENDENT P-VALUES'
      WRITE(*,*) 'ENTER M,P(1),...,P(M)'
      READ(*,*) M,(Q(I),I=1,M)
      S = ZERO
      DO 5 I = 1,M
         S = S+Q(I)
    5 CONTINUE
      NS = DINT(S)
      PC = S**M
      IF(NS.EQ.0) GO TO 15
      DO 10 I = 1,NS
         PC = PC+(-ONE)**I*(S-I)**M*COMB(M,I)
   10 CONTINUE
   15 PC = PC/FAC(M)
      WRITE(*,20) M, ' = NUMBER OF P-VALUES'
   20 FORMAT(T16,I5,A)
      WRITE(*,25) S, ' = OBSERVED EDGINGTON STATISTIC S'
   25 FORMAT(T5,G16.8,A)
      WRITE(*,25) PC, ' = COMBINED P-VALUE OF S'
      END
C
C
      DOUBLE PRECISION FUNCTION COMB(N,M)
C
      DOUBLE PRECISION  ONE,PI,R,Z,D,F,U1,U2,U3
C
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      COMB = DEXP(U1-U2-U3)
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION FAC(N)
      IMPLICIT REAL*8(A-H,O-Z)
C
      ONE = 1.0D0
      FAC = ONE
      IF(N.EQ.0) GO TO 20
      DO 10 I = 1,N
         FAC = FAC*I
   10 CONTINUE
   20 RETURN
      END
