      PROGRAM INVBETA
      DOUBLE PRECISION X,P,Q,OUT,XINBTA
   10 WRITE(*,20) ' ENTER PROBABILITY, A, AND B PARAMETERS, OR,',
     +            ' ENTER ANY LETTER OF ALPHABET TO QUIT:'
   20 FORMAT(/,A,/,A,/)
      READ(*,*) X,P,Q
      OUT = XINBTA(X,P,Q)
      WRITE(*,30) ' INVERSE INCOMPLETE BETA QUANTILE VALUE IS: ',OUT
   30 FORMAT(A,G15.8)
      GO TO 10
   40 END
C
      DOUBLE PRECISION FUNCTION XINBTA(ALPHA,A,B)
      DOUBLE PRECISION ALPHA,A,B,ZERO,ONE,ACU,P,AA,BB,BETA,DLNBTA,R,Y,
     +       T,S,H,W,YPREV,BETAIN,SQ,PREV,G,ADJ,TX
      LOGICAL INDEX
      ZERO = 0.0D0
      ONE = 1.0D0
      XINBTA = ALPHA
      IF(ALPHA.LE.0.5D0) GO TO 10
      P = ONE-ALPHA
      AA = B
      BB = A
      INDEX = .TRUE.
      GO TO 20
   10 P = ALPHA
      AA = A
      BB = B
      INDEX = .FALSE.
   20 BETA = DLNBTA(AA,BB)
      R = DSQRT(ZERO-DLOG(P)*2)
      Y = R-(2.30753D0+0.27061D0*R)/(ONE+(0.99229D0+0.04481D0*R)*R)
      IF(AA.GT.ONE.AND.BB.GT.ONE) GO TO 50
      R = AA+AA
      T = ONE/(BB*9)
      T = R*(ONE-T+Y*DSQRT(T))**3
      IF(T.LE.ZERO) GO TO 30
      T = (AA*4+R-2)/T
      IF(T.LE.ONE) GO TO 40
      XINBTA = ONE-ONE*2/(T+1)
      GO TO 60
   30 XINBTA = ONE-DEXP((DLOG((ONE-P)*BB)+BETA)/BB)
      GO TO 60
   40 XINBTA = DEXP((DLOG(P*AA)+BETA)/AA)
      GO TO 60
   50 R = (Y*Y-3)/6
      S = ONE/(AA+AA-1)
      T = ONE/(BB+BB-1)
      H = ONE*2/(S+T)
      W = Y*DSQRT(H+R)/H-(T-S)*(R+ONE*5/6-ONE*2/(H*3))
      XINBTA = AA/(AA+BB*DEXP(W+W))
   60 R = ONE-AA
      T = ONE-BB
      YPREV = ZERO
      SQ = ONE
      PREV = ONE
      IF(XINBTA.LT.0.0001D0) XINBTA = 0.0001D0
      IF(XINBTA.GT.0.9999D0) XINBTA = 0.9999D0
      ML = -50
      KT = -5.0D0/AA**2-ONE/P**0.2D0-13.0D0
      IF(KT.LE.ML) KT = ML
      ACU = 10.0D0**KT
   70 Y = BETAIN(XINBTA,AA,BB)
      Y = (Y-P)*DEXP(BETA+R*DLOG(XINBTA)+T*DLOG(ONE-XINBTA))
      IF(Y*YPREV.LE.ZERO) PREV = MAX(SQ,1.0D-50)
      G = ONE
   80 ADJ = G*Y
      SQ = ADJ*ADJ
      IF (SQ.GE.PREV) GO TO 90
      TX = XINBTA-ADJ
      IF(TX.GE.ZERO.AND.TX.LE.ONE) GO TO 100
   90 G = G/3
      GO TO 80
  100 IF(PREV.LE.ACU) GO TO 110
      IF(Y*Y.LE.ACU) GO TO 110
      IF(TX.EQ.ZERO.OR.TX.EQ.ONE) GO TO 90
      IF(TX.EQ.XINBTA) GO TO 110
      XINBTA = TX
      YPREV = Y
      GO TO 70
  110 IF(INDEX) XINBTA = ONE-XINBTA
      END
C
      DOUBLE PRECISION FUNCTION BETAIN(X,A,B)
      DOUBLE PRECISION X,A,B,ONE,TOL,AB,CX,XX,AA,BB,TERM,AI,RX,TEMP,
     +       DLNBTA
      LOGICAL INDEX
      ONE = 1.0D0
      TOL = 0.1D-7
      BETAIN = X
      AB = A+B
      CX = ONE-X
      IF(A.GE.AB*X) GO TO 10
      XX = CX
      CX = X
      AA = B
      BB = A
      INDEX = .TRUE.
      GO TO 20
   10 XX = X
      AA = A
      BB = B
      INDEX = .FALSE.
   20 TERM = ONE
      AI = ONE
      BETAIN = ONE
      NS = IDINT(BB+CX*AB)
      RX = XX/CX
   30 TEMP = BB-AI
      IF(NS.EQ.0) RX = XX
   40 TERM = TERM*TEMP*RX/(AA+AI)
      BETAIN = BETAIN+TERM
      TEMP = DABS(TERM)
      IF(TEMP.LE.TOL.AND.TEMP.LE.TOL*BETAIN) GO TO 50
      AI = AI+1
      NS = NS-1
      IF(NS.GE.0) GO TO 30
      TEMP = AB
      AB = AB+1
      GO TO 40
   50 BETAIN = BETAIN*DEXP(AA*DLOG(XX)+(BB-1)*DLOG(CX)
     +         -DLNBTA(AA,BB))/AA
      IF(INDEX) BETAIN = ONE-BETAIN
      END
C
      DOUBLE PRECISION FUNCTION DLNBTA(A,B)
      DOUBLE PRECISION A,B,DLNGAM
      DLNBTA = DLNGAM(A)+DLNGAM(B)-DLNGAM(A+B)
      END
C
      DOUBLE PRECISION FUNCTION DLNGAM(X)
      DOUBLE PRECISION X,ONE,Z,D,PI,F
      ONE  = 1.0D0
      Z  = X-1
      D  = ONE
      PI = DATAN(ONE)*4
      F  = Z+10
      DO 10 J = 1,9
         D = D*(Z+J)
   10 CONTINUE
      DLNGAM = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)
     +         -ONE/((F**3)*360)+ONE/((F**5)*1260)-ONE/((F**7)*1680)
     +         +ONE/((F**9)*1188)
      END
