      PROGRAM PROBC
      DOUBLE PRECISION P,OUT,PTOC
   10 WRITE(*,*) 'ENTER UPPER TAIL PROBABILITY AND DF VALUES, OR,'
      WRITE(*,*) 'ENTER ANY ALPHABET LETTER TO QUIT:'
      READ(*,*) P,N
      IF(P.LE.0.0D0) STOP 'PROBABILITY LESS THAN OR EQUAL TO 0'
      IF(P.GE.1.0D0) STOP 'PROBABILITY GREATER THAN OR EQUAL TO 1'
      OUT = PTOC(P,N)
      WRITE(*,20) 'CHI-SQUARE VALUE = ',OUT
   20 FORMAT(T5,A,E16.8)
      GO TO 10
      END
C
C
      DOUBLE PRECISION FUNCTION PTOC(P,N)
      DOUBLE PRECISION P,C(21),A(19),ZERO,ONE,PTOZ,F,F1,T,F2
      ZERO = 0.0D0
      ONE = 1.0D0
      C(1)  =  1.565326D-3
      C(2)  =  1.060438D-3
      C(3)  = -6.950356D-3
      C(4)  = -1.323293D-2
      C(5)  =  2.277679D-2
      C(6)  = -8.986007D-3
      C(7)  = -1.513904D-2
      C(8)  =  2.530010D-3
      C(9)  = -1.450117D-3
      C(10) =  5.169654D-3
      C(11) = -1.153761D-2
      C(12) =  1.128186D-2
      C(13) =  2.607083D-2                                                      C
      C(14) = -0.2237368D0
      C(15) =  9.780499D-5
      C(16) = -8.426812D-4
      C(17) =  3.125580D-3
      C(18) = -8.553069D-3
      C(19) =  1.348028D-4
      C(20) =  0.4713941D0
      C(21) =  1.0000886D0
      A(1)  =  1.264616D-2
      A(2)  = -1.425296D-2
      A(3)  =  1.400483D-2
      A(4)  = -5.886090D-3
      A(5)  = -1.091214D-2
      A(6)  = -2.304527D-2
      A(7)  =  3.135411D-3
      A(8)  = -2.728484D-4
      A(9)  = -9.699681D-3
      A(10) =  1.316872D-2
      A(11) =  2.618914D-2
      A(12) = -0.2222222D0
      A(13) =  5.406674D-5
      A(14) =  3.483789D-5
      A(15) = -7.274761D-4
      A(16) =  3.292181D-3
      A(17) = -8.729713D-3
      A(18) =  0.4714045D0
      A(19) =  ONE
      IF(N-2) 10,20,30
   10 PTOC = PTOZ(P/2)
      PTOC = PTOC*PTOC
      RETURN
   20 PTOC = ZERO-DLOG(P)*2
      RETURN
   30 F  = ONE*N
      F1 = ONE/F
      T  = PTOZ(ONE-P)
      F2 = DSQRT(F1)*T
      IF(N.GE.(2+IDINT(DABS(T)*4))) GO TO 40
      PTOC = (((((((C(1)*F2+C(2))*F2+C(3))*F2+C(4))*F2
     +       +C(5))*F2+C(6))*F2+C(7))*F1+((((((C(8)+C(9)*F2)*F2
     +       +C(10))*F2+C(11))*F2+C(12))*F2+C(13))*F2+C(14)))*F1
     +       +(((((C(15)*F2+C(16))*F2+C(17))*F2+C(18))*F2
     +       +C(19))*F2+C(20))*F2+C(21)
      GO TO 50
   40 PTOC = (((A(1)+A(2)*F2)*F1+(((A(3)+A(4)*F2)*F2
     +       +A(5))*F2+A(6)))*F1+(((((A(7)+A(8)*F2)*F2+A(9))*F2
     +       +A(10))*F2+A(11))*F2+A(12)))*F1+(((((A(13)*F2
     +       +A(14))*F2+A(15))*F2+A(16))*F2+A(17))*F2*F2
     +       +A(18))*F2+A(19)
   50 PTOC = F*PTOC**3
      END
C
      DOUBLE PRECISION FUNCTION PTOZ(P)
      DOUBLE PRECISION ZERO,ONE,HALF,TOL,P0,P1,P2,P3,P4,Q0,Q1,Q2,Q3,Q4,
     +       PS,P,Y1
      ZERO = 0.0D0
      ONE  = 1.0D0
      HALF = 0.5D0
      TOL  = 1.0D-20
      P0   = -0.322232431088D0
      P1   = -1.0D0
      P2   = -0.342242088547D0
      P3   = -0.204231210245D-1
      P4   = -0.453642210148D-4
      Q0   =  0.993484626060D-1
      Q1   =  0.588581570495D0
      Q2   =  0.531103462366D0
      Q3   =  0.103537752850D0
      Q4   =  0.385607006340D-2
      PTOZ = ZERO
      PS = P
      IF(PS.GT.HALF) PS = ONE-PS
      IF(PS.LT.TOL) RETURN
      IF(PS.EQ.HALF) RETURN
      Y1 = DSQRT(DLOG(ONE/(PS*PS)))
      PTOZ = Y1+((((Y1*P4+P3)*Y1+P2)*Y1+P1)*Y1+P0)
     +         /((((Y1*Q4+Q3)*Y1+Q2)*Y1+Q1)*Y1+Q0)
      IF(P.LT.HALF) PTOZ = P1*PTOZ
      END
