      PROGRAM VARKAP
C
C        PROGRAM MODIFIED 12/3/2004
C
      DOUBLE PRECISION  ROW(100),COL(100),W(10000),
     +                  TOT,T,T1,T2,ZT,PNL,PNU,P
      INTEGER  MCELL(10000)
C
      WRITE(*,*) 'ENTER: COMMON NUMBER OF ROWS AND COLUMNS:'
      READ(*,*) NROW
      DO 10 I = 1,NROW
         WRITE(*,*) 'ENTER FREQUENCIES FOR ROW',I
         READ(*,*) (MCELL(NROW*(J-1)+I),J = 1,NROW)
   10 CONTINUE
      DO 20 I = 1,NROW
         WRITE(*,*) 'ENTER WEIGHTS FOR ROW',I
         READ(*,*) (W(NROW*(J-1)+I),J = 1,NROW)
   20 CONTINUE
      CALL EKAPV(NROW,NROW,MCELL,W,ROW,COL,TOT,T,T1,T2,ZT)
      CALL NORMAL(ZT,PNL,PNU)
      N = IDINT(TOT)
      P = DMIN1(PNL,PNU)*2
      WRITE(*,25) 'TWO-WAY CONTINGENCY TABLE ANALYSES WITH ',
     +          NROW,' ROWS, ',NROW,' COLUMNS, & ',N,' CASES'
      WRITE(*,30) T, ' = OBSERVED R BY R KAPPA STATISTIC T'
      WRITE(*,35) T1,T2, ' = E[T] & VAR(T)'
      WRITE(*,30) ZT, ' = (T-E[T])/SQRT(VAR(T))'
      WRITE(*,35) PNL,PNU, ' = LOWER-TAIL & UPPER-TAIL P-VALUES OF T'
      WRITE(*,30) P, ' = TWO-SIDED P-VALUE OF T'
   25 FORMAT(T2,A,I3,A,I3,A,I7,A)
   30 FORMAT(T5,D16.9,A)
   35 FORMAT(T5,D16.9,D16.9,A)
      END
C
C
      SUBROUTINE EKAPV(NROW,NCOL,MCELL,W,ROW,COL,TOT,T,T1,T2,ZT)
C
      DOUBLE PRECISION  ROW(NROW),COL(NCOL),W(NROW,NCOL),X,EX,
     +    T,T1,T2,ZT,ZERO,ONE,TOT,COR,RC,RCC1,RCC2,RRC1,RRC2,
     +    RRCC1,RRCC2,RRCC3,RRCC4
      INTEGER  MCELL(NROW,NCOL)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DO 10 I = 1,NROW
       ROW(I) = ZERO
       DO 5 J = 1,NCOL
        ROW(I) = ROW(I)+ONE*MCELL(I,J)
    5  CONTINUE
   10 CONTINUE
      DO 20 J = 1,NCOL
       COL(J) = ZERO
       DO 15 I = 1,NROW
        COL(J) = COL(J)+ONE*MCELL(I,J)
   15  CONTINUE
   20 CONTINUE
      TOT = ZERO
      DO 30 I = 1,NROW
       TOT = TOT+ROW(I)
   30 CONTINUE
      X = ZERO
      COR = ZERO
      RC = ZERO
      RCC1 = ZERO
      RCC2 = ZERO
      RRC1 = ZERO
      RRC2 = ZERO
      RRCC1 = ZERO
      RRCC2 = ZERO
      RRCC3 = ZERO
      RRCC4 = ZERO
      DO 40 I = 1,NROW
       DO 35 J = 1,NCOL
        X = X+W(I,J)*MCELL(I,J)
        COR = COR+W(I,J)*ROW(I)*COL(J)
        RC = RC+W(I,J)**2*ROW(I)*(TOT-ROW(I))*COL(J)*(TOT-COL(J))
   35  CONTINUE
   40 CONTINUE
      DO 50 I = 1,NROW
       DO 49 J = 1,NCOL-1
        DO 48 JJ = J+1,NCOL
         RCC1 = RCC1+W(I,J)*W(I,JJ)*ROW(I)*(TOT-ROW(I))*COL(J)*COL(JJ)
         RCC2 = RCC2+W(I,JJ)*W(I,J)*ROW(I)*(TOT-ROW(I))*COL(JJ)*COL(J)
   48   CONTINUE
   49  CONTINUE
   50 CONTINUE
      DO 60 I = 1,NROW-1
       DO 59 II = I+1,NROW
        DO 58 J = 1,NCOL
         RRC1 = RRC1+W(I,J)*W(II,J)*ROW(I)*ROW(II)*COL(J)*(TOT-COL(J))
         RRC2 = RRC2+W(II,J)*W(I,J)*ROW(II)*ROW(I)*COL(J)*(TOT-COL(J))
   58   CONTINUE
   59  CONTINUE
   60 CONTINUE
      DO 70 I = 1,NROW-1
       DO 69 II = I+1,NROW
        DO 68 J = 1,NCOL-1
         DO 67 JJ = J+1,NCOL
          RRCC1 = RRCC1+W(I,J)*W(II,JJ)*ROW(I)*ROW(II)*COL(J)*COL(JJ)
          RRCC2 = RRCC2+W(II,J)*W(I,JJ)*ROW(II)*ROW(I)*COL(J)*COL(JJ)
          RRCC3 = RRCC3+W(I,JJ)*W(II,J)*ROW(I)*ROW(II)*COL(JJ)*COL(J)
          RRCC4 = RRCC4+W(II,JJ)*W(I,J)*ROW(II)*ROW(I)*COL(JJ)*COL(J)
   67    CONTINUE
   68   CONTINUE
   69  CONTINUE
   70 CONTINUE
      X = X/TOT
      EX = COR/TOT**2
      T = ONE-X/EX
      T1 = ZERO
      T2 = (RC-RCC1-RCC2-RRC1-RRC2+RRCC1+RRCC2+RRCC3+RRCC4)
     +     /((TOT-1)*COR**2)
      ZT = (T-T1)/DSQRT(T2)
      RETURN
      END
C
C
      SUBROUTINE NORMAL(Z,PNL,PNU)
C
C   SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF Z
C   BEING EITHER ( < OR = ) OR ( > OR = ) THE OBSERVED VALUE OF Z.
C
      DOUBLE PRECISION  Z,PNL,PNU,PROB,ZERO,ONE,PI,G,A,B,C,E,H,
     +   U,W,E1,E2,E3,E4,E5
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 20
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 10
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 20
   10 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   20 IF(Z.GT.ZERO) THEN
         PNU = PROB
         PNL = ONE-PROB
      ELSE
         PNL = PROB
         PNU = ONE-PROB
      END IF
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-709.1D0) E = DEXP(G)
      RETURN
      END
