      PROGRAM GMA
C
C   GAIL-MANTEL APPROXIMATION FOR NUMBER OF REFERENCE TABLES FOR A RXC TABLE
C
C        PROGRAM MODIFIED 3/17/02
C
      DOUBLE PRECISION  R(100),C(100),ZERO,ONE,TWO,HALF,TEN,PI,ZC,
     +    A,B,D,E,T,LCOMB,RL,RRL
      INTEGER  MCELL(100,100),NR(100),NC(100),NROW,NCOL,I,J
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      HALF = 0.5D0
      TEN = 1.0D1
      PI = DATAN(ONE)*4
      WRITE(*,*) 'ENTER: NUMBER OF ROWS AND NUMBER OF COLUMNS'
      READ(*,*) NROW,NCOL
      ZC = ONE*NCOL
      DO 10 I = 1,NROW
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*) (MCELL(I,J),J = 1,NCOL)
   10 CONTINUE
      T = ZERO
      DO 30 I = 1,NROW
         NR(I) = 0
         DO 20 J = 1,NCOL
            NR(I) = NR(I)+MCELL(I,J)
   20    CONTINUE
         R(I) = ONE*NR(I)
         T = T+R(I)
   30 CONTINUE
      DO 50 J = 1,NCOL
         NC(J) = 0
         DO 40 I = 1,NROW
            NC(J) = NC(J)+MCELL(I,J)
   40    CONTINUE
         C(J) = ONE*NC(J)
   50 CONTINUE
      D = ZERO
      DO 60 I = 1,NROW
         D = D+R(I)*(R(I)+ZC)
   60 CONTINUE
      D = D*(ZC-1)/((ZC+1)*ZC**2)
      E = ZERO
      DO 70 J = 1,NCOL
         E = E+C(J)**2
   70 CONTINUE
      E = (E-T*T/ZC)*(ZC-1)/(D*ZC)
      A = HALF*(ZC-1)*DLOG10((ZC-1)/(TWO*PI*D*ZC))
     +    +HALF*DLOG10(ZC)-E/(TWO*DLOG(TEN))
      B = ZERO
      DO 80 I = 1,NROW
         B = B+LCOMB(NR(I)+NCOL-1,NCOL-1)
   80 CONTINUE
      RL = A+B
      WRITE(*,90) 'LOG10 OF NUMBER OF REFERENCE TABLES = ',RL
   90 FORMAT(T2,A,D20.13)
      RRL = TEN**RL
      WRITE(*,90) 'NUMBER OF REFERENCE TABLES = ',RRL
      END
C
C
      DOUBLE PRECISION FUNCTION LCOMB(N,M)
C
      DOUBLE PRECISION  ONE,PI,R,Z,D,F,U1,U2,U3
C
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      R = DLOG(PI*2)/2
      Z = ONE+N
      D = Z
      F = Z+10
      DO 10 I = 1,9
         D = D*(Z+I)
   10 CONTINUE
      U1 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+M
      D = Z
      F = Z+10
      DO 20 I = 1,9
         D = D*(Z+I)
   20 CONTINUE
      U2 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1188)
      Z = ONE+N-M
      D = Z
      F = Z+10
      DO 30 I = 1,9
         D = D*(Z+I)
   30 CONTINUE
      U3 = (F*2-1)*DLOG(F)/2-F+R-DLOG(D)+ONE/(F*12)-ONE/(F**3*360)
     +        +ONE/(F**5*1260)-ONE/(F**7*1680)+ONE/(F**9*1180)
      LCOMB = (U1-U2-U3)/DLOG(1.0D1)
      RETURN
      END
