      PROGRAM RXC
C
C        PROGRAM MODIFIED 2/3/2006
C
      DOUBLE PRECISION  ROW(100),COL(100),Q(6,2),R(100,6),C(100,6),
     +    T,T1,T2,ZT,GAMT,PROBT,S,S1,S2,ZS,GAMS,PROBS,
     +    CS,PCS,CZ,PZS,TLR,PLS
      INTEGER  MCELL(10000)
      CHARACTER  FOUT*40
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*)  'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,5)  FOUT
    5 FORMAT(A)
      WRITE(*,*) 'ENTER: NUMBER OF ROWS AND NUMBER OF COLUMNS'
      READ(*,*) NROW, NCOL
      M = (NROW-1)*(NCOL-1)
      DO 10 I = 1,NROW
         WRITE(*,*) 'ENTER ROW',I
         READ(*,*) (MCELL(NROW*(J-1)+I),J = 1,NCOL)
   10 CONTINUE
      CALL CHI2(NROW,NCOL,MCELL,ROW,COL,R,C,Q,
     +          T,T1,T2,ZT,GAMT,S,S1,S2,ZS,GAMS,CS,CZ,TLR)
      CALL PVALUE(ZT,GAMT,PROBT)
      CALL PVALUE(ZS,GAMS,PROBS)
      IF(CS.GT.ZERO) THEN
         CALL CHISQ(CS,M,PCS)
      ELSE
         PCS = ONE
      ENDIF
      IF(CZ.GT.ZERO) THEN
         CALL CHISQ(CZ,M,PZS)
      ELSE
         PZS = ONE
      ENDIF
      IF(TLR.GT.ZERO) THEN
         CALL CHISQ(TLR,M,PLS)
      ELSE
         PLS = ONE
      ENDIF
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,20) 'TWO-WAY CONTINGENCY TABLE ANALYSES WITH ',
     +          NROW,' ROWS AND ',NCOL,' COLUMNS'
      WRITE(6,30) T, ' = OBSERVED R BY C CHI-SQUARE STATISTIC T'
      WRITE(6,30) T1, ' = E[T]'
      WRITE(6,30) T2, ' = VAR(T)'
      WRITE(6,30) GAMT, ' = SKEWNESS OF T'
      WRITE(6,30) ZT, ' = (T-E[T])/SQRT(VAR(T))'
      WRITE(6,30) PROBT, ' = P-VALUE OF T'
      WRITE(6,30) CS, ' = PEARSON R BY C CHI-SQUARE STATISTIC'
      WRITE(6,30) PCS,' = ASYMPTOTIC PEARSON CHI-SQUARE P-VALUE'
      WRITE(6,30) S,  ' = OBSERVED MODIFIED R BY C STATISTIC S'
      WRITE(6,30) S1, ' = E[S]'
      WRITE(6,30) S2, ' = VAR(S)'
      WRITE(6,30) GAMS, ' = SKEWNESS OF S'
      WRITE(6,30) ZS, ' = (S-E[S])/SQRT(VAR(S))'
      WRITE(6,30) PROBS, ' = P-VALUE OF S'
      WRITE(6,30) CZ, ' = ZELTERMAN R BY C CHI-SQUARE STATISTIC'
      WRITE(6,30) PZS,' = ASYMPTOTIC ZELTERMAN CHI-SQUARE P-VALUE'
      WRITE(6,30) TLR,' = LOG LR TEST STATISTIC'
      WRITE(6,30) PLS,' = ASYMPTOTIC LOG LR TEST P-VALUE'
   20 FORMAT(T2,A,I3,A,I3,A)
   30 FORMAT(T5,D16.9,A)
      END
C
C
      SUBROUTINE CHI2(NROW,NCOL,MCELL,ROW,COL,R,C,Q,
     +           T,T1,T2,ZT,GAMT,S,S1,S2,ZS,GAMS,CS,CZ,TLR)
C
      DOUBLE PRECISION  ROW(NROW),COL(NCOL),R(NROW,6),C(NCOL,6),Q(6,2),
     +    T,T1,T2,ZT,GAMT,GT,HT,ET2,ET3,S,S1,S2,ZS,GAMS,FS,GS,HS,
     +    R11,R21,R31,R41,R22,R32,R42,R13,R23,R33,R43,R53,R63,
     +    R34,R44,R54,R64,R25,R35,R45,R55,R36,R46,R56,R66,
     +    C11,C21,C31,C41,C22,C32,C42,C13,C23,C33,C43,C53,C63,
     +    C34,C44,C54,C64,C25,C35,C45,C55,C36,C46,C56,C66,
     +    ZERO,ONE,TOT,SUM,CS,CZ,TLR
      INTEGER  MCELL(NROW,NCOL)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      DO 10 I = 1,NROW
         ROW(I) = ZERO
   10 CONTINUE
      DO 20 J = 1,NCOL
         COL(J) = ZERO
   20 CONTINUE
      DO 40 I = 1,NROW
         DO 30 J = 1,NCOL
            ROW(I) = ROW(I)+ONE*MCELL(I,J)
            COL(J) = COL(J)+ONE*MCELL(I,J)
   30    CONTINUE
   40 CONTINUE
      TOT = ZERO
      DO 50 I = 1,NROW
         TOT = TOT+ROW(I)
   50 CONTINUE
      DO 60 I = 1,NROW
         R(I,1) = ROW(I)
   60 CONTINUE
      DO 80 I = 1,NROW
         DO 70 K = 1,5
            R(I,K+1) = R(I,K)*(R(I,1)-K)
   70    CONTINUE
   80 CONTINUE
      DO 90 J = 1,NCOL
         C(J,1) = COL(J)
   90 CONTINUE
      DO 110 J = 1,NCOL
         DO 100 K = 1,5
            C(J,K+1) = C(J,K)*(C(J,1)-K)
  100    CONTINUE
  110 CONTINUE
      Q(1,1) = TOT-3
      DO 120 I = 2,4
         Q(I,1) = Q(I-1,1)*(TOT-4+I)
  120 CONTINUE
      Q(1,2) = TOT-5
      DO 130 I = 2,6
         Q(I,2) = Q(I-1,2)*(TOT-6+I)
  130 CONTINUE
      CALL RORC(NROW,TOT,ROW,R,R11,R21,R31,R41,R22,R32,R42,R13,R23,R33,
     +    R43,R53,R63,R34,R44,R54,R64,R25,R35,R45,R55,R36,R46,R56,R66)
      CALL RORC(NCOL,TOT,COL,C,C11,C21,C31,C41,C22,C32,C42,C13,C23,C33,
     +    C43,C53,C63,C34,C44,C54,C64,C25,C35,C45,C55,C36,C46,C56,C66)
      GT=((R41+R42)*(C41+C42)+(R31*C31*2+(R31+R32)*(C31+C32))*Q(1,1)*2
     +   +(R21*C21*6+(R21+R22)*(C21+C22))*Q(2,1)+R11*C11*Q(3,1))/Q(4,1)
      HT=((R63+R64*3+R66)*(C63+C64*3+C66)+((R53+R54)*(C53+C54)*4
     +   +(R53+R54*2+R55+R56)*(C53+C54*2+C55+C56))*Q(1,2)*3
     +   +(R43*C43*32+(R43+R44)*(C43+C44)*18+(R43+R45)*(C43+C45)*12
     +   +(R43+R44+R45*2+R46)*(C43+C44+C45*2+C46)*3)*Q(2,2)
     +   +(R33*C33*68+(R33+R34)*(C33+C34)*3+(R33+R35)*(C33+C35)*18
     +   +(R33+R35*3+R36)*(C33+C35*3+C36))*Q(3,2)+(R23*C23*28
     +   +(R23+R25)*(C23+C25)*3)*Q(4,2)+R13*C13*Q(5,2))/Q(6,2)
      ET2=(GT*(TOT-1)-TOT-(NROW*NCOL-NROW-NCOL)*2-1)*(TOT-1)
      ET3=((HT-GT*3)*(TOT-1)+TOT*2+(NROW*NCOL-NROW-NCOL)*3+1)*(TOT-1)**2
      FS=(TOT-NROW)*(TOT-NCOL)/TOT/(TOT-1)
      GS=((R41+R42)*(C41+C42)+R31*C31*Q(1,1)*4+R21*C21*Q(2,1)*2)/Q(4,1)
      HS=((R63+R64*3+R66)*(C63+C64*3+C66)+(R53+R54)*(C53+C54)*Q(1,2)*12
     +   +(R43*C43*32+(R43+R44)*(C43+C44)*6)*Q(2,2)+R33*C33*Q(3,2)*32
     +   +R23*C23*Q(4,2)*4)/Q(6,2)
      SUM = ZERO
      DO 150 I = 1,NROW
         DO 140 J = 1,NCOL
            SUM = SUM+(ONE*MCELL(I,J))**2/ROW(I)/COL(J)
  140    CONTINUE
  150 CONTINUE
      T = (TOT-1)*(SUM-1)
      T1 = ONE*(NROW-1)*(NCOL-1)
      T2 = ET2-T1**2
      ZT = (T-T1)/DSQRT(T2)
      GAMT = (ET3-T1*T2*3-T1**3)/(DSQRT(T2))**3
      CS = TOT*(SUM-1)
      S = ZERO
      DO 170 I = 1,NROW
         DO 160 J = 1,NCOL
            S = S+ONE*MCELL(I,J)*(MCELL(I,J)-1)/ROW(I)/COL(J)
  160    CONTINUE
  170 CONTINUE
      TLR = ZERO
      DO 190 I = 1,NROW
         DO 180 J = 1,NCOL
            IF(MCELL(I,J).GT.0) THEN
               TLR = TLR+DLOG(TOT*MCELL(I,J)/ROW(I)/COL(J))*MCELL(I,J)
            ELSE
               TLR = TLR+ZERO
            ENDIF
  180    CONTINUE
  190 CONTINUE
      TLR = TLR*2
      S1 = FS
      S2 = GS-FS*FS
      ZS = (S-S1)/DSQRT(S2)
      GAMS = (HS-FS*GS*3+FS*FS*FS*2)/DSQRT((GS-FS*FS)**3)
      CZ = TOT*(S-1)+NROW*NCOL
      RETURN
      END
C
C
      SUBROUTINE RORC(NCAT,TOT,CAT,X,X11,X21,X31,X41,X22,X32,X42,
     +    X13,X23,X33,X43,X53,X63,X34,X44,X54,X64,X25,X35,X45,X55,
     +    X36,X46,X56,X66)
C
      DOUBLE PRECISION  CAT(NCAT),X(NCAT,6),X11,X21,X31,X41,X22,X32,X42,
     +    X13,X23,X33,X43,X53,X63,X34,X44,X54,X64,X25,X35,X45,X55,
     +    X36,X46,X56,X66,CAT0,CAT1,CAT2,CAT3,FCAT,TOT,ZERO,ONE
C
      ZERO = 0.0D0
      ONE = 1.0D0
      FCAT = ONE*NCAT
      X22 = FCAT*(FCAT-1)
      X32 = (TOT-FCAT)*(FCAT-1)
      X36 = X22*(FCAT-2)
      X46 = X32*(FCAT-2)
      X11 = ZERO
      X21 = ZERO
      X31 = ZERO
      X41 = ZERO
      X42 = ZERO
      X13 = ZERO
      X23 = ZERO
      X33 = ZERO
      X43 = ZERO
      X53 = ZERO
      X63 = ZERO
      X34 = ZERO
      X44 = ZERO
      X54 = ZERO
      X64 = ZERO
      X66 = ZERO
      DO 10 I=1,NCAT
          CAT0 = TOT-CAT(I)*2-FCAT+2
          CAT1 = TOT-CAT(I)-FCAT+1
          CAT2 = CAT(I)**2
          CAT3 = CAT(I)**3
          X11 = X11+X(I,1)/CAT2
          X21 = X21+X(I,2)/CAT2
          X31 = X31+X(I,3)/CAT2
          X41 = X41+X(I,4)/CAT2
          X13 = X13+X(I,1)/CAT3
          X23 = X23+X(I,2)/CAT3
          X33 = X33+X(I,3)/CAT3
          X43 = X43+X(I,4)/CAT3
          X53 = X53+X(I,5)/CAT3
          X63 = X63+X(I,6)/CAT3
          X34 = X34+X(I,1)*CAT1/CAT2
          X44 = X44+X(I,2)*CAT1/CAT2
          X54 = X54+X(I,3)*CAT1/CAT2
          X64 = X64+X(I,4)*CAT1/CAT2
          X42 = X42+(CAT(I)-1)*CAT1
          X66 = X66+(CAT(I)-1)*CAT0*CAT1
   10 CONTINUE
      X25 = X11*(FCAT-1)
      X35 = X21*(FCAT-1)
      X45 = X31*(FCAT-1)
      X55 = X41*(FCAT-1)
      X56 = X42*(FCAT-2)
      RETURN
      END
C
C
      SUBROUTINE PVALUE(Z,GAM,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE
C        OF Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE
C        OF Z.
C
      DOUBLE PRECISION  Z,GAM,PROB,ZERO,ONE,PI,A,B,C,D,E,F,G,H,R,
     +   U,W,X,Y,E1,E2,E3,E4,E5,G1,G2,G3,H0,H1,H2,H3,H4
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      IF(DABS(GAM).LT.0.01D0) GO TO 50
      R = ONE*2/DABS(GAM)
      D = R*R
      DO 10 I = 1,9
         D = D*(R*R+I)
   10 CONTINUE
      F = R*R+10
      U = (F*2-1)*DLOG(F)/2-F+DLOG(PI*2)/2-DLOG(D)+ONE/(F*12)-
     +    ONE/(F*F*F*360)
      G1 = 0.0375D0
      G2 = 0.075D0
      G3 = 0.0125D0
      H1 = ZERO
      H2 = ZERO
      A  = R*R-1
      B  = R*R*(DLOG(R)-1)-U
      W  = -1.99D0/GAM
      IF(GAM.LT.ZERO) GO TO 30
      IF(Z.LT.W) THEN
         PROB = ONE
         RETURN
      END IF
      X = Z
      Y = Z+15
      DO 20 I = 1,199
         G = A*DLOG(R+X+G1*(I*2-1))-R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R+X+G2*I)-R*(X+G2*I)+B
         H2 = H2+E(G)
   20 CONTINUE
      G = A*DLOG(R+X)-R*X+B
      H0 = E(G)
      G = A*DLOG(R+Y)-R*Y+B
      H3 = E(G)
      G = A*DLOG(R+X+G1*399)-R*(X+G1*399)+B
      H4 = E(G)
      PROB = G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   30 IF(Z.GT.W) THEN
         PROB = ZERO
         RETURN
      END IF
      X = Z-15
      Y = Z
      DO 40 I = 1,199
         G = A*DLOG(R-X-G1*(I*2-1))+R*(X+G1*(I*2-1))+B
         H1 = H1+E(G)
         G = A*DLOG(R-X-G2*I)+R*(X+G2*I)+B
         H2 = H2+E(G)
   40 CONTINUE
      G = A*DLOG(R-X)+R*X+B
      H0 = E(G)
      G = A*DLOG(R-Y)+R*Y+B
      H3 = E(G)
      G = A*DLOG(R-X-G1*399)+R*(X+G1*399)+B
      H4 = E(G)
      PROB = ONE-G3*(H0+(H1+H4)*4+H2*2+H3)
      RETURN
   50 PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-738.0D0) GO TO 70
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 60
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*E(G)/DSQRT(PI*2)
      GO TO 70
   60 B = 2.2D0
      C = 4.9D0
      PROB = E(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   70 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION E(G)
C
      DOUBLE PRECISION G
C
      E = 0.0D0
      IF(G.GE.-738.0D0) E = DEXP(G)
      RETURN
      END
C
C
      SUBROUTINE CHISQ(T,N,P)
      DOUBLE PRECISION T,ZERO,ONE,V,X,P,PI,PX,A,B,E1,E2,E3,E4,E5,H,W
      ZERO = 0.0D0
      ONE = 1.0D0
      IF(T.LE.ZERO) THEN
         P = ONE
         GO TO 60
      END IF
      IF(N.EQ.1) THEN
         X = DSQRT(T)
         CALL PVN(X,PX)
         P = PX*2
         GO TO 60
      END IF
      V = ONE*N
      IF(V/2-N/2.GT.0.1D0) GO TO 30
      P = DEXP(-T/2)
      IF(N.LT.3) GO TO 60
      K = (N-2)/2
      B = ONE
      DO 20 J = 1,K
         L = J
         A = ONE
         DO 10 I = 1,L
            A = A*T/(2*I)
   10    CONTINUE
         B = B+A
   20 CONTINUE
      P = P*B
      GO TO 60
   30 PI = DATAN(ONE)*4
      E1 = 0.31938153D0
      E2 = -0.356563782D0
      E3 = 1.781477937D0
      E4 = -1.821255978D0
      E5 = 1.330274429D0
      H = 0.2316419D0
      W = ONE/(H*DSQRT(T)+1)
      P = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*DEXP(-T/2)/DSQRT(PI/2)
      IF(N.LT.2) GO TO 60
      K = (N-1)/2
      B = ZERO
      DO 50 J = 1,K
         L = J
         A = ONE
         DO 40 I = 1,L
            A = A*T/(2*I-1)
   40    CONTINUE
         B = B+A
   50 CONTINUE
      P = P+B*DEXP(-T/2)/DSQRT(PI*T/2)
   60 RETURN
      END
C
C
      SUBROUTINE PVN(Z,PROB)
C
C        SUBROUTINE PVALUE CALCULATES THE PROBABILITY OF A VALUE OF
C        Z BEING GREATER THAN OR EQUAL TO THE OBSERVED VALUE OF Z.
C
      DOUBLE PRECISION  Z,PROB,ZERO,ONE,PI,G,A,B,C,EE,H,
     +   U,W,E1,E2,E3,E4,E5
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PI = DATAN(ONE)*4
      PROB = ZERO
      G = -Z*Z/2
      IF(G.LT.-709.1D0) GO TO 20
      A = 4.2D0
      U = DABS(Z)
      IF(U.GT.A) GO TO 10
      E1 =  0.31938153D0
      E2 = -0.356563782D0
      E3 =  1.781477937D0
      E4 = -1.821255978D0
      E5 =  1.330274429D0
      H  =  0.2316419D0
      W  =  ONE/(H*DABS(Z)+1)
      PROB = ((((E5*W+E4)*W+E3)*W+E2)*W+E1)*W*EE(G)/DSQRT(PI*2)
      GO TO 20
   10 B = 2.2D0
      C = 4.9D0
      PROB = EE(G)*(ONE/U-ONE/U**3+B/U**C)/DSQRT(PI*2)
   20 IF(Z.LT.ZERO) PROB = ONE-PROB
      RETURN
      END
C
C
      DOUBLE PRECISION FUNCTION EE(G)
C
      DOUBLE PRECISION G
C
      EE = 0.0D0
      IF(G.GE.-709.1D0) EE = DEXP(G)
      RETURN
      END
